'**********    VBButton Control v1.0 for VB 3.0/4.0     **********
'*******                                                    ******
'****          Property of WolfeByte Ltd. 1995, 1996          ****
'**                                                             **
'**      This program is protected by and subject to all        **
'**    Federal copyright laws governing the duplication and     **
'**    distribution of authored software.  With the purchase    **
'**    and use of this program you agree to release WolfeByte   **
'**    Ltd. of all liability and/or damages as related to the   **
'**    use of this program and also acknowledge that no claims  **
'**     or warranties regarding its usage have been offered.    **
'****                                                         ****
'*******                                                    ******
'**********        Update Version 1.1  June 7, 1996     **********

Option Explicit

'All subs are in this module.  To create a new control - create a new
'picturebox and size it to the desired button size.  Then copy the code
'from the demo applications following events and paste them into the same
'events in your project: 1) Form_Load  2) Picture1_DblClick,
'...GotFocus, ...LostFocus, ...MouseMove, ...MouseUp and ...MouseDown. Rename any
'picture1 references in this code to the names of your new controls.

'Make a record structure for font types
Type ftType
  ftName As String
  ftSize As Integer
  ftBold As Integer
  ftItalic As Integer
  ftUnderline As Integer
  ftColor  As Long
End Type

'Make a record structure for a cmdBtn - one time only
Type cmProps
    cmdState As Integer
    cmdBevel As Integer
    cmdFont As ftType
    cmdText As String
    cmdVAlign As String
    cmdHAlign As String
    cmdMultiline As Integer
    cmdFocus As Integer
End Type

'Declare array of the record type for number of cmdBtns you want (Option Base is 0 - default)
Global cmdBtn(5) As cmProps

Sub DefineCmdBtn0 (inPct As PictureBox)

'This sub needs to be called once from the form load event so that the
'cmdBtn(0) is assigned its properties.  Create one for each cmdBtn you
'have - DefinecmdBtn1..2...  You also have to increase the number of
'elements in the cmdBtn array which is dimensioned in the declarations
'section - Global cmdBtn(x) as cmProps.


'Properties for cmdBtn0
    
    inPct.AutoRedraw = True               'Allow creation of picturebox in memory
    inPct.ScaleMode = 3                   'Set the picturebox scale to pixels
    inPct.BorderStyle = 0                 'Remove picturebox border
    inPct.BackColor = QBColor(7)          'Button color (not needed if you set the picturebox color at design time)
    cmdBtn(0).cmdState = -1               '-1 button up, 0 button down
    cmdBtn(0).cmdBevel = 1                'Button bevel height
    cmdBtn(0).cmdFont.ftName = "MS Sans Serif" 'Button font name
    cmdBtn(0).cmdFont.ftSize = 8.25       'Button font size
    cmdBtn(0).cmdFont.ftBold = True       'Button font bold
    cmdBtn(0).cmdFont.ftItalic = False    'Button font italic
    cmdBtn(0).cmdFont.ftUnderline = False 'Button font underline
    cmdBtn(0).cmdFont.ftColor = QBColor(0)'Button font color
    cmdBtn(0).cmdText = "Command1"        'Button text - use the ~ to force line break - multiline must be true
    cmdBtn(0).cmdVAlign = "center"        'Button Text Vert Alignment
    cmdBtn(0).cmdHAlign = "center"        'Button Text Horz Alignment
    cmdBtn(0).cmdMultiline = False        'Determines if Text will span multiple lines
    cmdBtn(0).cmdFocus = False            'Button has focus?

End Sub

Sub DefineCmdBtn1 (inPct As PictureBox)

'See DefineCmdBtn0 for descriptions
    
    inPct.AutoRedraw = True
    inPct.ScaleMode = 3
    inPct.BorderStyle = 0
    inPct.BackColor = QBColor(7)
    cmdBtn(1).cmdState = -1
    cmdBtn(1).cmdBevel = 2
    cmdBtn(1).cmdFont.ftName = "MS Sans Serif"
    cmdBtn(1).cmdFont.ftSize = 8.25
    cmdBtn(1).cmdFont.ftBold = False
    cmdBtn(1).cmdFont.ftItalic = False
    cmdBtn(1).cmdFont.ftUnderline = False
    cmdBtn(1).cmdFont.ftColor = QBColor(0)
    cmdBtn(1).cmdText = "Picture~Button"
    cmdBtn(1).cmdVAlign = "center"
    cmdBtn(1).cmdHAlign = "center"
    cmdBtn(1).cmdMultiline = True
    cmdBtn(1).cmdFocus = False

End Sub

Sub DefineCmdBtn2 (inPct As PictureBox)

'See DefineCmdBtn0 for descriptions

    inPct.AutoRedraw = True
    inPct.ScaleMode = 3
    inPct.BorderStyle = 0
    inPct.BackColor = QBColor(7)
    cmdBtn(2).cmdState = -1
    cmdBtn(2).cmdBevel = 3
    cmdBtn(2).cmdFont.ftName = "MS Sans Serif"
    cmdBtn(2).cmdFont.ftSize = 10
    cmdBtn(2).cmdFont.ftBold = True
    cmdBtn(2).cmdFont.ftItalic = False
    cmdBtn(2).cmdFont.ftUnderline = False
    cmdBtn(2).cmdFont.ftColor = QBColor(4)
    cmdBtn(2).cmdText = "OK"
    cmdBtn(2).cmdVAlign = "center"
    cmdBtn(2).cmdHAlign = "center"
    cmdBtn(2).cmdMultiline = False
    cmdBtn(2).cmdFocus = False

End Sub

Sub DefineCmdBtn3 (inPct As PictureBox)

'See DefineCmdBtn0 for descriptions

    inPct.AutoRedraw = True
    inPct.ScaleMode = 3
    inPct.BorderStyle = 0
    inPct.BackColor = QBColor(7)
    cmdBtn(3).cmdState = -1
    cmdBtn(3).cmdBevel = 2
    cmdBtn(3).cmdFont.ftName = "MS Sans Serif"
    cmdBtn(3).cmdFont.ftSize = 8.25
    cmdBtn(3).cmdFont.ftBold = True
    cmdBtn(3).cmdFont.ftItalic = True
    cmdBtn(3).cmdFont.ftUnderline = False
    cmdBtn(3).cmdFont.ftColor = 0
    cmdBtn(3).cmdText = "Cancel"
    cmdBtn(3).cmdVAlign = "center"
    cmdBtn(3).cmdHAlign = "right"
    cmdBtn(3).cmdMultiline = False
    cmdBtn(3).cmdFocus = False
   
End Sub

Sub DefineCmdBtn4 (inPct As PictureBox)

'See DefineCmdBtn0 for descriptions

    inPct.AutoRedraw = True
    inPct.ScaleMode = 3
    inPct.BorderStyle = 0
    inPct.BackColor = QBColor(7)
    cmdBtn(4).cmdState = -1
    cmdBtn(4).cmdBevel = 1
    cmdBtn(4).cmdFont.ftName = "MS Sans Serif"
    cmdBtn(4).cmdFont.ftSize = 8.25
    cmdBtn(4).cmdFont.ftBold = True
    cmdBtn(4).cmdFont.ftItalic = True
    cmdBtn(4).cmdFont.ftUnderline = False
    cmdBtn(4).cmdFont.ftColor = 0
    cmdBtn(4).cmdText = "Exit"
    cmdBtn(4).cmdVAlign = "center"
    cmdBtn(4).cmdHAlign = "center"
    cmdBtn(4).cmdMultiline = False
    cmdBtn(4).cmdFocus = False

End Sub

Sub DefineCmdBtn5 (inPct As PictureBox)

'See DefineCmdBtn0 for descriptions

    inPct.AutoRedraw = True
    inPct.ScaleMode = 3
    inPct.BorderStyle = 0
    inPct.BackColor = QBColor(3)
    cmdBtn(5).cmdState = -1
    cmdBtn(5).cmdBevel = 3
    cmdBtn(5).cmdFont.ftName = "MS Sans Serif"
    cmdBtn(5).cmdFont.ftSize = 10
    cmdBtn(5).cmdFont.ftBold = False
    cmdBtn(5).cmdFont.ftItalic = True
    cmdBtn(5).cmdFont.ftUnderline = False
    cmdBtn(5).cmdFont.ftColor = QBColor(14)
    cmdBtn(5).cmdText = "All~Sizes And~Colors"
    cmdBtn(5).cmdVAlign = "center"
    cmdBtn(5).cmdHAlign = "center"
    cmdBtn(5).cmdMultiline = True
    cmdBtn(5).cmdFocus = False

End Sub

Sub DrawBtnTxt (inPct As PictureBox, lbLeft%, lbTop%, lbRight%, lbBottom%, lbText$, lbHorzAlign$, txVertAlign$, inMultiLine%)

'Called from within this module to draw text on picturebox and align accordingly
'within area passed in.  The vertical alignment of the text is a percent of
'distance from the top of the area - pass in one of these -> 0 = top,
'.5 = middle, 1 = bottom.

'The Multi-Line will split on words that have a space between them as well
'   as split up long words.  If the word is to long to fit horizontal on the
'   button it will be split between two or more lines.  It also implements
'   a char by char compare instead of using instr for the word break so that
'   individual chars can be filtered out and acted upon specifically
'   i.e. as with the CRLFChr.  The CRLFChr "~" acts as an immediate break
'   at the word and starts the new text on the next line.
'   This can be modified for the '&' character as well.
   
   Dim inBegin As Integer      'Beginning position
   Dim inEnd As Integer        'Ending position
   Dim inBreak As Integer      'Where to break the line
   Dim inTextLen As Integer    'Length of text to be output
   Dim inPctTOLen As Integer   'Text Output Length
   Dim strText As String       'Work String
   Dim txChar As String        'Character working with
   Dim inElement As Integer    'Element working with
   Dim arText()  As String     'Array of text
   Dim inTextHeight As Integer 'Height of all text lines
   Dim lbVertAlign As Single   'Vertical Alignment of Text
   Const CRLFChr = "~"         'Character to act as CRLF

   'Set the vertical alignment - Default is "center"
   If LCase(txVertAlign) = "top" Then
      lbVertAlign = 0
   ElseIf LCase(txVertAlign) = "bottom" Then
      lbVertAlign = 1
   Else
      lbVertAlign = .5
   End If

   inPctTOLen = lbRight - lbLeft  'Text Output Length
   inTextLen = inPct.TextWidth(lbText) 'Length of text

   'This checks to see if the line needs to be split
   '   Always split if it is a multi-line
   If inMultiLine Or ((inTextLen > inPctTOLen) And inMultiLine) Then
      inBegin = 1        'Begin with first position
      inElement = 1      'We know we have at least 1 element

      For inEnd = 1 To Len(lbText) + 1  'Look at all chrs
         txChar = Mid$(lbText, inEnd, 1)
         If txChar = " " Then
            inBreak = inEnd    'Keep Break on a space position
         End If

         'This is where the check for CRLFChr is
         If (inPct.TextWidth(strText) + inPct.TextWidth(txChar)) < inPctTOLen And txChar <> "" And txChar <> CRLFChr Then
            strText = strText & txChar
         Else
           
            ReDim Preserve arText(inElement)
            If txChar = "" Then  'End of text
               inBreak = inEnd
            End If
            If txChar = CRLFChr Then  'CRLF character
               inBreak = inEnd
            End If
            If inBreak = 0 Then  'Break on words
               inBreak = inEnd - 1
               arText(inElement) = Mid$(strText, 1, inEnd - inBegin)
            Else
               arText(inElement) = Mid$(strText, 1, inBreak - inBegin)
            End If
            
            'Text height of each line for centering
            inTextHeight = inTextHeight + inPct.TextHeight(arText(inElement))

            'End of Text ?
            If txChar <> "" Then
               strText = ""
               inBegin = inBreak + 1
               inEnd = inBreak
               inBreak = 0
               inElement = inElement + 1
            End If
         End If
         
      Next
      
   Else
      'We still need to move the text to be processed
      ReDim arText(1)   'There is only 1 element
      arText(1) = lbText 'Move the text in
      inTextHeight = inPct.TextHeight(arText(1)) 'Get the heigth of text
   End If
   
   'Calculate the Y position
   inPct.CurrentY = lbTop + (((lbBottom - lbTop) * lbVertAlign) - (inTextHeight * lbVertAlign))
   
   'Don't let it go over the top
   If inPct.CurrentY < lbTop Then
      inPct.CurrentY = lbTop
   End If
   
   For inElement = 1 To UBound(arText) 'Loop thru all element strings

      Select Case LCase(lbHorzAlign)
         Case "left"
            inPct.CurrentX = lbLeft
   
         Case "right"
            inPct.CurrentX = lbRight - inPct.TextWidth(arText(inElement))
   
         Case "center"
            inPct.CurrentX = lbLeft + (((lbRight - lbLeft) / 2) - (inPct.TextWidth(arText(inElement)) / 2))
         Case Else  'Default "center"
            inPct.CurrentX = lbLeft + (((lbRight - lbLeft) / 2) - (inPct.TextWidth(arText(inElement)) / 2))
      End Select
    
      inPct.Print arText(inElement)
   Next

   ReDim arText(0)
End Sub

Sub DrawCmdBtn (inCmd As cmProps, inPct As PictureBox)
 
'Called each time the button changes focus or up/down

    Dim x%, y%

    inPct.Cls                  'Used to clear text (not need if not using picture)
    Select Case inCmd.cmdFocus 'Draw button according to focus state
       Case True
          inPct.FillStyle = 1
          inPct.Line (0, 0)-(inPct.ScaleWidth - 1, inPct.ScaleHeight - 1), 0, B
          'Focus rectangle in these two loops
          For x = inCmd.cmdBevel + 3 To inPct.ScaleWidth - inCmd.cmdBevel - 3 Step 2
             inPct.PSet (x, inCmd.cmdBevel + 2), 0
             inPct.PSet (x, inPct.ScaleHeight - inCmd.cmdBevel - 3), 0
          Next
          For y = inCmd.cmdBevel + 3 To inPct.ScaleHeight - inCmd.cmdBevel - 3 Step 2
             inPct.PSet (inCmd.cmdBevel + 2, y), 0
             inPct.PSet (inPct.ScaleWidth - inCmd.cmdBevel - 3, y), 0
          Next
       Case False
          inPct.Line (0, inPct.ScaleHeight - 1)-(inPct.ScaleWidth, inPct.ScaleHeight - 1), 0
          inPct.Line (inPct.ScaleWidth - 1, 0)-(inPct.ScaleWidth - 1, inPct.ScaleHeight), 0
    End Select
    
    SetFonts inCmd.cmdFont, inPct 'Prepare font settings
    
    Select Case inCmd.cmdState
      Case -1                     'Button up
         For x = 0 To inCmd.cmdBevel - 1
           inPct.Line (1 + x, inPct.ScaleHeight - 2 - x)-(inPct.ScaleWidth - 2 - x + 1, inPct.ScaleHeight - 2 - x), RGB(92, 92, 92)
           inPct.Line (1 + x, 1 + x)-(inPct.ScaleWidth - 2 - x + 1, 1 + x), RGB(255, 255, 255)
           inPct.Line (inPct.ScaleWidth - 2 - x, 1 + x)-(inPct.ScaleWidth - 2 - x, inPct.ScaleHeight - 2 - x), RGB(92, 92, 92)
           inPct.Line (1 + x, 1 + x)-(1 + x, inPct.ScaleHeight - 2 - x), RGB(255, 255, 255)
         Next
         DrawBtnTxt inPct, inCmd.cmdBevel + 3, inCmd.cmdBevel + 1, inPct.ScaleWidth - inCmd.cmdBevel - 3, inPct.ScaleHeight - inCmd.cmdBevel - 3, inCmd.cmdText, inCmd.cmdHAlign, inCmd.cmdVAlign, inCmd.cmdMultiline
      Case 0                      'Button down
         DrawBtnTxt inPct, inCmd.cmdBevel + 5, inCmd.cmdBevel + 2, inPct.ScaleWidth - inCmd.cmdBevel - 1, inPct.ScaleHeight - inCmd.cmdBevel - 2, inCmd.cmdText, inCmd.cmdHAlign, inCmd.cmdVAlign, inCmd.cmdMultiline
    End Select

End Sub

Sub SetFonts (inFont As ftType, inPct As PictureBox)
    
'Called from within this module to set the fonts of the picturebox.  The font
'name will not be checked for correct spelling (if errors - check name spelling first).
    
    inPct.FontName = inFont.ftName
    inPct.FontSize = inFont.ftSize
    inPct.FontBold = inFont.ftBold
    inPct.FontItalic = inFont.ftItalic
    inPct.FontUnderline = inFont.ftUnderline
    inPct.ForeColor = inFont.ftColor
    
End Sub

