Option Explicit

Type BITMAPINFOHEADER
    biSize          As Long
    biWidth         As Long
    biHeight        As Long
    biPlanes        As Integer
    biBitCount      As Integer
    biCompression   As Long
    biSizeImage     As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed       As Long
    biClrImportant  As Long
    End Type

Type RGBQUAD
    rgbBlue         As String * 1
    rgbGreen        As String * 1
    rgbRed          As String * 1
    rgbReserved     As String * 1
    End Type

Type BITMAPINFO
    bmiHeader       As BITMAPINFOHEADER
    bmiColors(0 To 255)  As RGBQUAD
    End Type

Type BITMAPFILEHEADER
    bfType          As Integer
    bfSize          As Long
    bfReserved1     As Integer
    bfReserved2     As Integer
    bfOffBits       As Long
    End Type

Global Const SRCCOPY = &HCC0020
Global Const SRCPAINT = &HEE0086
Global Const SRCAND = &H8800C6
Global Const SRCINVERT = &H660046
Global Const SRCERASE = &H440328
Global Const NOTSRCCOPY = &H330008
Global Const NOTSRCERASE = &H1100A6
Global Const MERGECOPY = &HC000CA
Global Const MERGEPAINT = &HBB0226
Global Const PATCOPY = &HF00021
Global Const PATPAINT = &HFB0A09
Global Const PATINVERT = &H5A0049
Global Const DSTINVERT = &H550009
Global Const BLACKNESS = &H42&
Global Const WHITENESS = &HFF0062
Global Const BLACKONWHITE = 1
Global Const WHITEONBLACK = 2
Global Const COLORONCOLOR = 3
Global Const BI_RGB = 0&
Global Const BI_RLE8 = 1&
Global Const BI_RLE4 = 2&
Global Const TRANSPARENT = 1
Global Const OPAQUE = 2

Global Const CBM_INIT = &H4&

Declare Function CreateCompatibleDC Lib "GDI" (ByVal hDC As Integer) As Integer
Declare Function DeleteDC Lib "GDI" (ByVal hDC As Integer) As Integer
Declare Function CreateCompatibleBitmap Lib "GDI" (ByVal hDC As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer) As Integer
Declare Function CreateDIBitmap Lib "GDI" (ByVal hDC As Integer, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, ByVal lpInitBits As String, lpInitInfo As BITMAPINFO, ByVal wUsage As Integer) As Integer
Declare Function CreateDIBitmapFromGlobalMem Lib "GDI" Alias "CreateDIBitmap" (ByVal hDC As Integer, lpInfoHeader As BITMAPINFOHEADER, ByVal dwUsage As Long, ByVal lpInitBits As Long, lpInitInfo As BITMAPINFO, ByVal wUsage As Integer) As Integer
Declare Function DeleteObject Lib "GDI" (ByVal hObject As Integer) As Integer
Declare Function SelectObject Lib "GDI" (ByVal hDC As Integer, ByVal hObject As Integer) As Integer
Declare Function BitBlt Lib "GDI" (ByVal hDestDC As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal dwROP As Long) As Integer
Declare Function SetDIBitsToDevice Lib "GDI" (ByVal hDC As Integer, ByVal DestX As Integer, ByVal DestY As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal SrcX As Integer, ByVal SrcY As Integer, ByVal nStartScan As Integer, ByVal nNumScans As Integer, ByVal lpBits As Long, lpBitsInfo As BITMAPINFO, ByVal wUsage As Integer) As Integer
Declare Function StretchDIBits Lib "GDI" (ByVal hDC As Integer, ByVal DestX As Integer, ByVal DestY As Integer, ByVal nDestWidth As Integer, ByVal nDestHeight As Integer, ByVal SrcX As Integer, ByVal SrcY As Integer, ByVal nSrcWidth As Integer, ByVal nSrcHeight As Integer, ByVal lpBits As Long, lpBitsInfo As BITMAPINFO, ByVal wUsage As Integer, ByVal dwROP As Long) As Integer

Private Function MinLong (A As Long, B As Long)
    If A < B Then
	MinLong = A
      Else
	MinLong = B
      End If
    End Function

Sub ReadBitmapFile (ByVal FileName As String, bmFileHeader As BITMAPFILEHEADER, bmInfo As BITMAPINFO, hPixelData As Integer)

    Const BitmapFile% = 1
    Const BufferSize% = 1024
    Dim wPixelDataSelector As Integer
    Dim PixelBytesToRead As Long
    Dim PixelBuffer As String * 1024
    Dim BytesStored As Long
    Dim MemOffset As Long
    'Dim NewPalette As LOGPALETTE

    Open FileName For Binary As BitmapFile%
    ' Read the header structures.
    Get BitmapFile%, 1, bmFileHeader
    Get BitmapFile%, Len(bmFileHeader) + 1, bmInfo
    PixelBytesToRead = bmInfo.bmiHeader.biSizeImage
    MemOffset = 0
    If PixelBytesToRead > 0 Then
    ' Allocate memory on Windows' global heap.
	hPixelData = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, PixelBytesToRead)
	wPixelDataSelector = GlobalHandleToSel(hPixelData)
	Do While PixelBytesToRead > 0
	    Get BitmapFile%, , PixelBuffer
	    BytesStored = MemoryWrite(wPixelDataSelector, MemOffset, ByVal PixelBuffer, MinLong(BufferSize%, PixelBytesToRead))
	    MemOffset = MemOffset + BufferSize%
	    PixelBytesToRead = PixelBytesToRead - BufferSize%
	    Loop
      Else
	hPixelData = 0
      End If
    Close
    End Sub

