Attribute VB_Name = "DrawDigit"
Option Explicit
Dim WidthX, LeftX, RightX, HeightY, TopY, PartY, MidY, BottomY As Integer
Sub DrawDigit_09(pic As Object, SrcDigit As Object)
    'pic: temporary location to draw images of digits
    'SrcDigit: images of digits, colon, and dot are saved in this arrayed Image Control
    
    Dim i As Integer
    SetScale pic   'Sets dimensions of LED
    DrawDigit pic, 0 'draw digit 0
   ' DrawDigit2 pic, 0
    SrcDigit(0).Picture = pic.Image 'save image of digit 0
   ' SrcDigit(i).Visible = True
    For i = 1 To 9  'draw digits 1 to 9
        Load SrcDigit(i) 'load image control 1 to 9
       ' SrcDigit(i).Left = SrcDigit(i - 1).Left + SrcDigit(i - 1).Width
       ' SrcDigit(i).Visible = True
        DrawDigit pic, i
       ' DrawDigit2 pic, i
        SrcDigit(i).Picture = pic.Image 'save image of i
    Next
  
    Load SrcDigit(10) 'colon
   ' SrcDigit(10).Left = SrcDigit(9).Left + SrcDigit(9).Width
   ' SrcDigit(10).Visible = True
    DrawColon pic
    SrcDigit(10).Picture = pic.Image 'colon
    
    Load SrcDigit(11) 'dot
   ' SrcDigit(11).Left = SrcDigit(10).Left + SrcDigit(10).Width
   ' SrcDigit(11).Visible = True
    DrawDot pic
    SrcDigit(11).Picture = pic.Image 'dot

    
End Sub
Sub DisplayDigits(Led As Object, SrcDigit As Object, StartIndex As Integer, CaseNum As Integer, NumLen As Integer, ByVal Num As Long)
    'Led: destination
    'SrcDigit: Source of LED, colon, and dot.
    'StartIndex: starting location in Led
    'CaseNum: method to display number
    'NumLen: number of digits, including pre 0
    'Num: number to display
    Dim Divider As Long
    Dim TempNum As Integer
    Dim i As Integer
    Dim index As Integer
    
    Select Case CaseNum
        Case 0: 'whole number
                Divider = 1
                For i = 1 To NumLen - 1
                    Divider = Divider * 10
                Next
                For i = 1 To NumLen
                    If i = NumLen Then
                        index = Num Mod 10
                    Else
                        index = Num \ Divider
                        Num = Num Mod Divider
                    End If
                    Led(StartIndex + i - 1) = SrcDigit(index)
                    Divider = Divider \ 10
                Next
        Case 1: 'mm:ss.ss
                'I use this case for my application
                TempNum = Num \ 100 'TempNum is now the total seconds
                'example: if Num = 45465, then total seconds = 454
                'and 65 are digits after the dot (.ss)
                index = TempNum \ 60 'minute
                Led(StartIndex).Picture = SrcDigit(index \ 10)
                Led(StartIndex + 1).Picture = SrcDigit(index Mod 10)
                Led(StartIndex + 2).Picture = SrcDigit(10)  'colon
                index = TempNum Mod 60 'second
                Led(StartIndex + 3).Picture = SrcDigit(index \ 10)
                Led(StartIndex + 4).Picture = SrcDigit(index Mod 10)
                index = Num Mod 100 'digits after dot
                Led(StartIndex + 6).Picture = SrcDigit(index \ 10)
                Led(StartIndex + 7).Picture = SrcDigit(index Mod 10)
        Case 2: 'hh:mm:ss
                'not implemented
        Case 3: ' whole number width hidden colon and dot (mm:ss.ss)
                'I use this case for my application
                TempNum = 0
                Divider = 1
                For i = 1 To NumLen - 1
                    Divider = Divider * 10
                Next
                For i = 1 To NumLen
                    If i = NumLen Then
                        index = Num Mod 10
                    Else
                        index = Num \ Divider
                        Num = Num Mod Divider
                    End If
                    If i = 3 Then 'skip colon
                      TempNum = 1
                    ElseIf i = 5 Then 'skip dot
                      TempNum = 2
                    End If
                    Led(StartIndex + TempNum + i - 1) = SrcDigit(index)
                    Divider = Divider \ 10
                Next
        
    End Select
End Sub
Sub DrawDot(pic As Object)
    pic.Cls
    pic.Width = 5
    
    pic.Line (1, MidY + 5)-(3, MidY + 4), pic.ForeColor, BF 'bottom
    
End Sub
Sub DrawColon(pic As Object)
    pic.Cls
    pic.Width = 5
    
    pic.Line (1, MidY - 5)-(3, MidY - 4), pic.ForeColor, BF 'top
    pic.Line (1, MidY + 5)-(3, MidY + 4), pic.ForeColor, BF 'bottom
    
End Sub
Private Sub SetScale(pic As Object)
    WidthX = pic.ScaleWidth - 2 'width of LED
    HeightY = pic.ScaleHeight - 3 'height
    LeftX = 3
    TopY = 1
    BottomY = HeightY
    RightX = WidthX
    PartY = HeightY \ 2 'height of segment
    MidY = TopY + PartY + 1
End Sub
Sub DrawDigit(pic As Object, Digit As Integer)
    pic.Cls
    Select Case Digit
        Case 0, 2, 3, 5 To 9: 'top
        pic.Line (LeftX, TopY + 1)-(RightX, TopY + 1), pic.ForeColor 'top
        pic.Line (LeftX + 1, TopY + 2)-(RightX - 1, TopY + 2), pic.ForeColor
    End Select
    Select Case Digit
        Case 0 To 4, 7 To 9: 'right top
        pic.Line (RightX, TopY + 2)-(RightX, MidY), pic.ForeColor 'right
        pic.Line (RightX - 1, TopY + 3)-(RightX - 1, MidY - 1), pic.ForeColor
    End Select
    Select Case Digit
        Case 0, 1, 3 To 9: 'right bottom
        pic.Line (RightX, MidY + 1)-(RightX, BottomY + 1), pic.ForeColor 'right
        pic.Line (RightX - 1, MidY + 2)-(RightX - 1, BottomY), pic.ForeColor
    End Select
    Select Case Digit
        Case 0, 2, 3, 5, 6, 8: 'bottom
        pic.Line (LeftX + 1, BottomY)-(RightX - 1, BottomY), pic.ForeColor 'top
        pic.Line (LeftX, BottomY + 1)-(RightX, BottomY + 1), pic.ForeColor
    End Select
    Select Case Digit
        Case 0, 2, 6, 8: 'left bottom
        pic.Line (LeftX - 1, MidY + 1)-(LeftX - 1, BottomY + 1), pic.ForeColor 'left
        pic.Line (LeftX, MidY + 2)-(LeftX, BottomY), pic.ForeColor
        
    End Select
    Select Case Digit
        Case 0, 4 To 6, 8, 9: 'Left Top
        pic.Line (LeftX - 1, TopY + 2)-(LeftX - 1, MidY), pic.ForeColor  'left
        pic.Line (LeftX, TopY + 3)-(LeftX, MidY - 1), pic.ForeColor
    End Select
    Select Case Digit
        Case 2 To 6, 8, 9: 'middle
        pic.Line (LeftX + 1, MidY - 1)-(RightX - 1, MidY - 1), pic.ForeColor 'top
        pic.Line (LeftX, MidY)-(RightX, MidY), pic.ForeColor   'middle
        pic.Line (LeftX + 1, MidY + 1)-(RightX - 1, MidY + 1), pic.ForeColor
    End Select
End Sub
Sub DrawDigit2(pic As Object, Digit As Integer)
    pic.Cls
    Select Case Digit
        Case 0, 2, 3, 5 To 9: 'top
        pic.Line (LeftX + 1, TopY)-(RightX - 1, TopY), pic.ForeColor  'top
        pic.Line (LeftX, TopY + 1)-(RightX, TopY + 1), pic.ForeColor 'middle
        pic.Line (LeftX + 1, TopY + 2)-(RightX - 1, TopY + 2), pic.ForeColor
    End Select
    Select Case Digit
        Case 0 To 4, 7 To 9: 'right top
        pic.Line (RightX + 1, TopY + 3)-(RightX + 1, MidY - 1), pic.ForeColor 'right
        pic.Line (RightX, TopY + 2)-(RightX, MidY), pic.ForeColor 'middle
        pic.Line (RightX - 1, TopY + 3)-(RightX - 1, MidY - 1), pic.ForeColor
    End Select
    Select Case Digit
        Case 0, 1, 3 To 9: 'right bottom
        pic.Line (RightX + 1, MidY + 2)-(RightX + 1, BottomY), pic.ForeColor  'right
        pic.Line (RightX, MidY + 1)-(RightX, BottomY + 1), pic.ForeColor 'middle
        pic.Line (RightX - 1, MidY + 2)-(RightX - 1, BottomY), pic.ForeColor
    End Select
    Select Case Digit
        Case 0, 2, 3, 5, 6, 8: 'bottom
        pic.Line (LeftX + 1, BottomY)-(RightX - 1, BottomY), pic.ForeColor 'top
        pic.Line (LeftX, BottomY + 1)-(RightX, BottomY + 1), pic.ForeColor 'middle
        pic.Line (LeftX + 1, BottomY + 2)-(RightX - 1, BottomY + 2), pic.ForeColor
    End Select
    Select Case Digit
        Case 0, 2, 6, 8: 'left bottom
        pic.Line (LeftX - 2, MidY + 2)-(LeftX - 2, BottomY), pic.ForeColor  'left
        pic.Line (LeftX - 1, MidY + 1)-(LeftX - 1, BottomY + 1), pic.ForeColor 'middle
        pic.Line (LeftX, MidY + 2)-(LeftX, BottomY), pic.ForeColor
        
    End Select
    Select Case Digit
        Case 0, 4 To 6, 8, 9: 'Left Top
        pic.Line (LeftX - 2, TopY + 3)-(LeftX - 2, MidY - 1), pic.ForeColor 'left
        pic.Line (LeftX - 1, TopY + 2)-(LeftX - 1, MidY), pic.ForeColor  'middle
        pic.Line (LeftX, TopY + 3)-(LeftX, MidY - 1), pic.ForeColor
    End Select
    Select Case Digit
        Case 2 To 6, 8, 9: 'middle
        pic.Line (LeftX + 1, MidY - 1)-(RightX - 1, MidY - 1), pic.ForeColor 'top
        pic.Line (LeftX, MidY)-(RightX, MidY), pic.ForeColor   'middle
        pic.Line (LeftX + 1, MidY + 1)-(RightX - 1, MidY + 1), pic.ForeColor
    End Select
End Sub
Sub DrawProgressBar(ProgBar As Object, currPos As Long, TotalLen As Long)
    
    Dim percent As Single
    Dim X As Integer
    
    If TotalLen <= 0 Then
        percent = 0
    Else
        percent = currPos / TotalLen
    End If
    X = percent * ProgBar.ScaleWidth
    ProgBar.Line (0, 0)-(X, ProgBar.Height), ProgBar.ForeColor, BF 'Progress so far
    'the following line is useful if backward progress is used
    ProgBar.Line (X + 1, 0)-(ProgBar.ScaleWidth, ProgBar.Height), ProgBar.BackColor, BF 'fill
    
End Sub
