Attribute VB_Name = "Module1"
Option Explicit
'Global Error Handling routine
'Just call this in your program and it will
'handle all errors in a module
'writes errors to a log file

'George W. Graff
'121 East Hammaker Street
'Thurmont MD 21788
'301-271-3836
'5/20/96
'Distribute Freely
'I am availble for offsite programming assignments
'E-mail = vbgeorge@paonline.com
' error handler constants

Global nReturn As Integer
Global cMsg As String

Global Const errExit = 0
Global Const errResume = 1
Global Const errNext = 2
Global Const errSelect = 3
Public Function errHandler(nErrorNumber As Integer, cErrText As String, nErrOption As Integer) As Integer
'Declarations



'building the message
cMsg = ""
cMsg = cMsg + "Err:" + Chr(9) + Str(nErrorNumber) + Chr(13)
cMsg = cMsg + "Text:" + Chr(9) + cErrText + Chr(13)
 
 
 ErrWriteLogFile cMsg
 

'handle option

Select Case nErrOption
    Case Is = errExit
        MsgBox cMsg, vbCritical, "Exiting program..."
        GoTo errHandlerEnd
    Case Is = errResume
        MsgBox cMsg, vbCritical, "Error"
        errHandler = errResume
    Case Is = errNext
        MsgBox cMsg, vbCritical, "Error"
        errHandler = errNext
    Case Is = errSelect
        nReturn = MsgBox(cMsg, vbCritical + vbAbortRetryIgnore, "Error")
        Select Case nReturn
        Case Is = vbAbort
           GoTo errHandlerEnd
        Case Is = vbRetry
            errHandler = errResume
        Case Is = vbIgnore
            errHandler = errNext
        End Select
 End Select
 Exit Function

errHandlerEnd:
    MsgBox "Click OK to Exit Program"
    End

End Function

Public Sub ErrWriteLogFile(cLogMsg)
On Error GoTo errWriteLogFileErr
    
    'write messages to logfile
    Dim cFile$
    Dim nFile
    Dim ErrDir$
    ErrDir = App.Path
    
    nFile = FreeFile()
    cFile = ErrDir + Format(Now, "mmddyyhhss") + ".err"
    Open cFile For Output As nFile
    Print #nFile, "***ERROR REPORT - [" + App.EXEName + "] ***"
    Print #nFile, ""
    Print #nFile, "DATE: " + Format(Now, "General Date")
    Print #nFile, ""
    Print #nFile, cLogMsg
    Print #nFile, ""
    Print #nFile, "***eof***"
    Close #nFile
    GoTo errWriteLogFileExit
    
errWriteLogFileErr:
    MsgBox Str(Err) + "-" + Error$, vbCritical, "Unable to Write Error Log"
        Exit Sub
errWriteLogFileExit:
 
End Sub
