VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "FHCmnDlgFileV1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'CmnDlgFile Class v1.0 by Frank Hipp 3/98

'''''''''' Constants for CmnDlg Flags
'
'Const OFN_ALLOWMULTISELECT = &H200
'Const OFN_CREATEPROMPT = &H2000
'Const OFN_ENABLEHOOK = &H20
'Const OFN_ENABLETEMPLATE = &H40
'Const OFN_ENABLETEMPLATEHANDLE = &H80
'Const OFN_EXPLORER = &H80000
'Const OFN_EXTENSIONDIFFERENT = &H400
'Const OFN_FILEMUSTEXIST = &H1000
'Const OFN_HIDEREADONLY = &H4
'Const OFN_LONGNAMES = &H200000
'Const OFN_NOCHANGEDIR = &H8
'Const OFN_NODEREFERENCELINKS = &H100000
'Const OFN_NOLONGNAMES = &H40000
'Const OFN_NONETWORKBUTTON = &H20000
'Const OFN_NOREADONLYRETURN = &H8000
'Const OFN_NOTESTFILECREATE = &H10000
'Const OFN_NOVALIDATE = &H100
'Const OFN_OVERWRITEPROMPT = &H2
'Const OFN_PATHMUSTEXIST = &H800
'Const OFN_READONLY = &H1
'Const OFN_SHAREAWARE = &H4000
'Const OFN_SHAREFALLTHROUGH = 2
'Const OFN_SHARENOWARN = 1
'Const OFN_SHAREWARN = 0
'Const OFN_SHOWHELP = &H10
                    
'structure (or User Defined Type in VB)
'passed as an argument to, and modified by
'GetOpenFilename and GetSaveFilename
'
Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

'my copy of the type
Private MyOF As OPENFILENAME

'Cancelled Property Variable
Private bCancelled As Boolean

'api declares
Private Declare Function GetOpenFileName _
    Lib "comdlg32.dll" Alias "GetOpenFileNameA" _
        (pOpenfilename As OPENFILENAME) _
            As Long
                    
Private Declare Function GetSaveFileName _
    Lib "comdlg32.dll" Alias "GetSaveFileNameA" _
        (pOpenfilename As OPENFILENAME) _
            As Long

Public Sub ShowOpen()
'a  public sub becomes a meathod
'of the class.Since MyOF is global
'to the class there is no need to pass
'it to the sub

'by calling GetOpenFilename we activate the
'dialog, modifing the MyOF type....And also checking
'the function return for 0 ... 0 indicates the user choose
'to close the dialog or clicked the Cancel button.

bCancelled = (GetOpenFileName(MyOF) = 0)

End Sub

Public Sub ShowSave()

bCancelled = (GetSaveFileName(MyOF) = 0)

End Sub

Private Sub Class_Initialize()
' set default values

With MyOF
    .hInstance = App.hInstance
    .lStructSize = Len(MyOF)
    .lpstrFile = String$(260, 0)
    .nMaxFile = Len(.lpstrFile)
End With

End Sub

Public Property Let Filter(ByVal sNewVal As String)
'write only property ...properties that have Property Let procedure
'without a coresponding Property Get procedure are Write Only ...
'you can set the property but  you cant read it.

Dim iPipeLoc As Integer

'change pipe characters to null characters
iPipeLoc = InStr(1, sNewVal, Chr$(124), vbTextCompare)
Do Until iPipeLoc = 0
     sNewVal = Left$(sNewVal, iPipeLoc - 1) & Chr$(0) & Right$(sNewVal, Len(sNewVal) - iPipeLoc)
    iPipeLoc = InStr(iPipeLoc, sNewVal, Chr$(124), vbTextCompare)
Loop
    
'add 2 more null characters to end
'and assign to MyOF.lpstrFilter
MyOF.lpstrFilter = sNewVal & Chr$(0) & Chr$(0)

End Property


Public Property Let Owner(ByVal lNewVal As Long)
'write only

MyOF.hwndOwner = lNewVal

End Property

Public Property Let flags(ByVal lNewVal As Long)
'write only

MyOF.flags = lNewVal

End Property


Public Property Let FilterIndex(ByVal lNewVal As Long)
'write only

MyOF.nFilterIndex = lNewVal

End Property

Public Property Get Filename() As String
'read/write

'trim Null characters from end of MyOF.lpstrFile
Filename = Left$(MyOF.lpstrFile, (InStr(MyOF.lpstrFile, vbNullChar) - 1))

End Property

Public Property Let Filename(ByVal sNewVal As String)
'read/write

'add Null Characters to end of MyOF.lpstrFile
MyOF.lpstrFile = sNewVal & String(260 - Len(sNewVal), vbNullChar)

End Property

Public Property Let Title(ByVal sNewVal As String)
'write only

MyOF.lpstrTitle = sNewVal

End Property

Public Property Let DefaultExt(ByVal sNewVal As String)
'write only

MyOF.lpstrDefExt = sNewVal

End Property

Public Property Get Cancelled() As Boolean
'read only

Cancelled = bCancelled

End Property

Public Property Let InitialDir(ByVal sNewVal As String)
'write only

MyOF.lpstrInitialDir = sNewVal

End Property
