Attribute VB_Name = "FH003"
Option Explicit

'FH002.BAS Version 3.0
'by Frank J. Hipp  March 1998

'''''''''''''required for On/OffTop Subs:
Declare Function SetWindowPos _
    Lib "user32" (ByVal hwnd As Long, _
        ByVal hWndInsertAfter As Long, _
            ByVal x As Long, _
                ByVal y As Long, _
                    ByVal cx As Long, _
                        ByVal cy As Long, _
                            ByVal wFlags As Long) _
                                As Long
  
'''''''''''''' required for Play sub:
Private Declare Function mciSendString _
    Lib "winmm.dll" Alias "mciSendStringA" _
        (ByVal lpstrCommand As String, _
            ByVal lpstrReturnString As String, _
                ByVal uReturnLength As Long, _
                    ByVal hWndCallback As Long) _
                        As Long

Public sAlias As String * 5

'''''''''''''''' required for GetCursorPos
Type PointAPI
    x As Long
    y As Long
End Type
Public Pnt As PointAPI

Declare Function GetCursorPos Lib _
    "user32" (lpPoint As PointAPI) _
        As Long

''''''''''''' required for GetActiveWindow
Declare Function GetActiveWindow _
    Lib "user32" () _
        As Long

''''''''''' Required for GetWinTempDir function
Declare Function GetTempPath Lib _
    "kernel32" Alias "GetTempPathA" _
        (ByVal nBufferLength As Long, _
            ByVal lpBuffer As String) As Long

''''''''' required for GetChildInfo sub
Declare Function FindWindow Lib "user32" Alias "FindWindowA" _
    (ByVal lpClassName As String, _
        ByVal lpWindowName As String) _
            As Long

Declare Function GetWindow Lib "user32" _
    (ByVal hwnd As Long, _
        ByVal wCmd As Long) _
            As Long

Declare Function GetClassName Lib "user32" Alias "GetClassNameA" _
(ByVal hwnd As Long, _
    ByVal lpClassName As String, _
        ByVal nMaxCount As Long) _
            As Long

' constants used with GetWindow wCmd Argument
Public Const GW_HWNDFIRST = 0
Public Const GW_HWNDLAST = 1
Public Const GW_HWNDNEXT = 2
Public Const GW_CHILD = 5

Type tApiInfo
     hw As Long '  hWnd
     cn As String ' Classname
End Type

' User Defined Type Dynamic Array
' (oganize related arrays )
Public Api_Info() As tApiInfo

' this needs to be Public For ParseString Sub.
'the sub modifies this global array
Public sWords() As String


Public Sub StopPlay()

'stops all file that are playing, AND
'releases the current file from use,
'if you use the Play sub you MUST
'call this sub before your app terminates,
'or the current media file will be tagged
'as in use by windows

'example StopPlay

On Error GoTo StopPlay_Error

Dim sReturnString As String * 128
Dim sCommandString As String
Dim h As Integer
Dim i As Integer
Dim l As Long

sReturnString = Space(128)

For h = 1 To 3
    Select Case h
        Case 1
            sAlias = "myavi"
        Case 2
            sAlias = "mymid"
        Case 3
            sAlias = "mywav"
    End Select
    For i = 1 To 2
        If i = 1 Then
            sCommandString = "stop " & sAlias
        Else
            sCommandString = "close " & sAlias
        End If
            
            l = mciSendString(sCommandString, _
                sReturnString, _
                    Len(sReturnString), _
                        0)
    Next i
Next h

StopPlay_Error:
End Sub
Public Sub Play _
    (sFilename As String)

'example Play "C:\MyWav.wav"

On Error GoTo Play_Error


Dim i As Integer
Dim l As Long
Dim sReturnString As String * 128
Dim sPlayStyle As String
Dim sCommandString As String

sReturnString = Space(128) ' this string will be modified
'by the API function, so we need to make sure that it is
'long enough , otherwise the return string
'would exceed its memory allocation ...

Select Case UCase(Right$(sFilename, 3))
    Case Is = "AVI"
        sPlayStyle = " type mciavi alias "
        sAlias = "myavi"
    Case Is = "MID"
        sPlayStyle = " type sequencer alias "
        sAlias = "mymid"
    Case Is = "WAV"
        sPlayStyle = " type waveaudio alias "
        sAlias = "mywav"
    Case Else
        Exit Sub
End Select

For i = 1 To 3
    Select Case i
        Case 1
            sCommandString = "close " & sAlias
        Case 2
            sCommandString = _
            "open " & Chr(34) & sFilename & Chr(34) & sPlayStyle & sAlias
        Case 3
            sCommandString = "play " & sAlias & " from 1"
    End Select
    
    l = mciSendString _
        (sCommandString, _
            sReturnString, _
                Len(sReturnString), _
                    0)
        
Next i

Play_Error:
End Sub

Public Sub Center _
    (frm As Form)

' center the Form
' example: Center Me

On Error GoTo Center_Error

frm.Move (Screen.Width - frm.Width) / 2, _
  (Screen.Height - frm.Height) / 2

Center_Error:
End Sub

Public Sub Wait _
  (delay As Single, _
    Optional bDoEvents As Boolean = True)

'Delay app the selected no. of seconds
'example  Wait 3.5,True

On Error GoTo Wait_Error

Dim StartTime As Single

StartTime = Timer
Do Until Timer >= StartTime + delay
    If bDoEvents Then DoEvents
Loop

Wait_Error:
End Sub

Public Sub OnTop _
  (frm As Form, _
    Optional bOnTop As Boolean = True)

'example: OnTop Me, or OnTop Me, False

On Error GoTo OnTop_Error

Dim lWinPos As Long

If IsMissing(bOnTop) Then bOnTop = True ' default

If VarType(bOnTop) <> vbBoolean Then Exit Sub

If bOnTop Then lWinPos = -1 Else lWinPos = -2

SetWindowPos frm.hwnd, lWinPos, 0, 0, 0, 0, &H2 Or &H1

OnTop_Error:
End Sub

Public Function FindFile _
    (sPath As String) _
        As Boolean

On Error GoTo FindFile_Error

FindFile = (Dir(sPath) <> "") ' evaluates to true or false

Exit Function

FindFile_Error:  ' if theres an error the file wasnt found
FindFile = False

End Function

Public Sub SaveString _
    (sText As String, _
        sPath As String, _
            Optional bOverWritePrompt As Boolean = False)

'Save sText as a NEW Text File, sPath
'example: SaveString thistxt$, "C:\NewFile.txt",False

On Error GoTo SaveString_Error

Dim iFNo As Integer

If bOverWritePrompt And FindFile(sPath) Then
    If MsgBox(AlignText("This File Already Exists: " & vbCrLf & vbCrLf & sPath & _
        vbCrLf & vbCrLf & "Replace Existing File ?"), vbQuestion + vbYesNo, _
            "Caution: Existing File Found") = vbNo Then Exit Sub
End If

iFNo = FreeFile ' get next availabe file number
Open sPath For Output As #iFNo
Print #iFNo, sText
Close #iFNo

SaveString_Error:
End Sub

Public Function ReadString _
    (sPath As String) _
        As String

'load a Text File into ReadString
' example MyTextFile$ = ReadString("C:\MyText.txt")

On Error GoTo ReadString_Error

Dim iFNo As Integer
Dim txt As String

If Not FindFile(sPath) Then
    ReadString = "FILE NOT FOUND" ' for debug only ?
    Exit Function
End If

iFNo = FreeFile ' get next availabe file number
Open sPath For Input As #iFNo
ReadString = Input(LOF(iFNo), #iFNo)
Close #iFNo


'check for extra vbCrLf at end of File and remove it
If Right$(ReadString, 2) = vbCrLf Then _
    ReadString = Left$(ReadString, Len(ReadString) - 2)
    
ReadString_Error:
End Function

Public Sub AddString _
    (sText As String, _
        sPath As String)

' Add New Line(s) to an existing Text file

On Error GoTo AddString_Error

Dim iFNo As Integer

If Not FindFile(sPath) Then Exit Sub

iFNo = FreeFile ' get next availabe file number
Open sPath For Append As #iFNo
Print #iFNo, sText
Close #iFNo

AddString_Error:
End Sub

Public Function AlignText _
    (sText As String) _
        As String

'Align(pad lines in) a Sting with multi lines
'mainly used for MsgBox, this sub will align
'the lines in a multiline txt string.
' works best with fixed width Fonts
'example sAlignedText$ = AlignText(sUnAlignedTxt$)

On Error GoTo AlignText_Error

Dim sAT1() As String 'AlignText array 1
Dim sAT2() As String ' Align Text array 2
Dim sLine As String
Dim iLongLine As Integer
Dim i As Integer
Dim J As Integer

' build sAT1() from sText [- vbLf's]
For i = 0 To Len(sText)
    ReDim Preserve sAT1(i)
    If Mid(sText, i + 1, 1) <> vbLf Then _
        sAT1(i) = Mid$(sText, i + 1, 1)
Next i

'build sAT2()[lines] from sAT1()[char's]
i = 0
Do Until i = UBound(sAT1)
    If sAT1(i) = vbCr Then
        ReDim Preserve sAT2(J)
        sAT2(J) = sLine
        J = J + 1
        sLine = ""
    Else
        sLine = sLine + sAT1(i)
    End If
    i = i + 1
Loop

' add LAST Line to sAT2
ReDim Preserve sAT2(J)
sAT2(J) = sLine

' get Longest Line Length
For i = 0 To J
    If Len(sAT2(i)) > iLongLine Then iLongLine = Len(sAT2(i))
Next i
 
'Pad sAT2() lines & build return string
For i = 0 To UBound(sAT2)
    If Len(sAT2(i)) > 0 Then _
        sAT2(i) = Space(Int(iLongLine - Len(sAT2(i))) / 2) & sAT2(i)
    AlignText = AlignText & sAT2(i) & vbCrLf
Next i
 
Exit Function

AlignText_Error:

AlignText = ""  '"AlignText Error: " & Err.Description ' for debug
End Function


Public Sub GetChildInfo _
    (vClsNameORhWnd As Variant)

' This sub populates the Api_Info Array, with:
' the classname (.cn) , and hWnd (.hw) of every child
'of a parent window.
' You must supply the parent classname OR hWnd.
'
'EXAMPLE:
'Private Sub Form_Click()
''GetChildInfo  "ExploreWClass"
'
'OR: GetChildInfo  xplor_hWnd
'(assuming xplor_hWnd = Explorers current hWnd)
'
'For I% = 0 To UBound(ApiInfo)
'Print "Classname :" & Api_Info(I%).cn & "  hWnd:"; Api_Info(I%).hw
'Next I%
'End Sub

On Error GoTo GetChildInfo_Error

Dim lPrntHWnd As Long
Dim vt As Integer
Dim ClsNmLen As Integer
Dim iCnt As Integer
Dim sChildClassName As String * 200

Select Case VarType(vClsNameORhWnd)
    Case vbString
        lPrntHWnd = FindWindow(CStr(vClsNameORhWnd), vbNullString)
    Case vbLong
        lPrntHWnd = CLng(vClsNameORhWnd)
    Case Else
        Exit Sub
    End Select

ReDim Api_Info(0)

Api_Info(0).hw = GetWindow(lPrntHWnd, GW_CHILD)
ClsNmLen = GetClassName _
    (Api_Info(0).hw, sChildClassName, Len(sChildClassName))
Api_Info(0).cn = Left(sChildClassName, ClsNmLen)

Do Until Api_Info(iCnt).hw = 0
    iCnt = iCnt + 1
    ReDim Preserve Api_Info(iCnt)
    Api_Info(iCnt).hw = GetWindow _
        (Api_Info(iCnt - 1).hw, GW_HWNDNEXT)
    ClsNmLen = GetClassName _
        (Api_Info(iCnt).hw, sChildClassName, Len(sChildClassName))
    Api_Info(iCnt).cn = Left(sChildClassName, ClsNmLen)
Loop

If UBound(Api_Info) > 0 Then ReDim Preserve Api_Info(iCnt - 1)

Exit Sub

GetChildInfo_Error:
Erase Api_Info
End Sub

Public Function GetListIndex _
  (cListControl As Control, _
    sItemText As String) _
      As Integer

'returns ListIndex of an Item in a list,
'supply control name (ListBox or ComboBox)
'and Item Text string
'EXAMPLE: Label1 = GetListIndex(Combo1,"Is Item?")
' very similar to SearchList procedure but checks for
'EXACT match

On Error GoTo GetListIndex_Error

Dim i As Integer

With cListControl
    For i = 0 To .ListCount - 1
        If InStr(sItemText, .List(i)) Then
            GetListIndex = i   ' match found
            Exit Function
        End If
    Next i
End With 'cListControl

' note there is no exit sub here,
' exit occurs at first match
GetListIndex_Error:
GetListIndex = -1 ' returns -1 if no matching item found(or Error)
                                 ' this value will be ignored by the Listbox
End Function

Public Function TrimPath _
    (sPath As String, _
        Optional sStyle As String)

On Error GoTo TrimPath_Error

'Performs a Fix or Trim on a Supplied Path String

's$ = "C:\Example\Path\Filename"
'x$ = TrimPath(s$) [no style supplied]    = "Filename"
'x$ = TrimPath(s$,"\")[add \ if needed]   = "C:\Example\Path\Filename\"
'x$ = TrimPath(s$,"D")                                  = "C:"
'x$ = TrimPath(s$,"D\")                                 = "C:\"
'x$ = TrimPath(s$,"P")                                   = "C:\Example\Path"
'x$ = TrimPath(s$,"P\")                                  = "C:\Example\Path\"

Dim i As Integer
Dim bBackSlash As Boolean

For i = Len(sPath) To 1 Step -1
    If InStr(i, sPath, "\", 1) = i Then
        bBackSlash = True
        Exit For
    End If
Next i

If Not bBackSlash Then
    TrimPath = ""
    Exit Function
End If

If sStyle = "" Then                 'default trim
    TrimPath = Right(sPath, Len(sPath) - i) 'returns just Filename
    Exit Function
Else
    If sStyle = "\" Then
        If Right$(sPath, 1) = "\" Then TrimPath = sPath _
            Else TrimPath = sPath & "\"
        Exit Function
    End If
End If

Select Case UCase(sStyle)
    Case Is = "D"                     'returns Drive:
        TrimPath = Left(sPath, 2)
    Case Is = "D\"                    'returns Drive:\
        TrimPath = Left(sPath, 3)
    Case Is = "P"                     'returns Drive:\Path
        TrimPath = Left(sPath, i - 1)
    Case Is = "P\"                    'returns Drive:\Path\
        TrimPath = Left(sPath, i)
    Case Else
        GoTo TrimPath_Error:
End Select

Exit Function

TrimPath_Error:
TrimPath = "" '"TrimPath Error: " &  Err.Description ' for debug
End Function

Public Function WinTempDir() _
    As String

On Error GoTo WinTempDir_Error

Dim lRet As Long
Dim sTempDir As String * 260 ' max length of win 32 path w/command line

sTempDir = String(260, vbNullChar) ' this string will be modified
''by the API function, so we need to make sure that it is
'long enough before we send it , otherwise the return string
'would exceed its memory allocation ...

lRet = GetTempPath(260, sTempDir)

' Trim Extra Null Char's
WinTempDir = TrimNulls(sTempDir)

Exit Function

WinTempDir_Error:
WinTempDir = "" '"WinTempDir Error: " &  Err.Description ' for debug
End Function

Public Function SearchList _
    (cList As ListBox, _
        sText As String) _
            As Integer

'example:
'Private Sub Text3_Change()
'List1.ListIndex = SearchList(List1, Text3.Text)
'End Sub

On Error GoTo SearchList_Error

Dim i As Integer

With cList
    For i = 0 To .ListCount - 1
        If InStr(1, Left(.List(i), Len(sText)), sText, 1) <> 0 Then
            SearchList = i
            Exit Function
        End If
    Next i
End With

' note there is no exit function here,
' exit occurs at first match
SearchList_Error:

SearchList = -1 ' returns -1 if no matching item found(or Error)
                              ' this value will be ignored by the Listbox
End Function

Public Sub UnloadAllForms()

On Error GoTo UnloadAllForms_Error

Dim frm As Form

For Each frm In Forms
    Unload frm
Next frm

UnloadAllForms_Error:
End Sub

Public Function TrimNulls _
    (sStr As String) _
        As String

On Error GoTo TrimNulls_Error

TrimNulls = Left$(sStr, (InStr(sStr, vbNullChar) - 1))

TrimNulls_Error:
End Function
Public Sub SmoothUnload _
    (frm As Form)
' fix  for jumpy unload of a form
' when it is on top of another form ...

On Error GoTo SmoothUnload_Error

With frm
    .Left = Screen.Width + 1000
    .Refresh
End With

Wait 0.1
Unload frm

SmoothUnload_Error:
End Sub

Public Sub ParseString _
    (sText As String)

Dim iSpcPos As Integer ' Counter

ReDim sWords(1) ' reset String Array

sWords(1) = Left$(sText, InStr(1, sText, " ")) ' get first word

iSpcPos = 1

Do
   iSpcPos = InStr(iSpcPos + 1, sText, " ")
   If iSpcPos = 0 Then Exit Do ' no match found
   ReDim Preserve sWords(UBound(sWords) + 1)
   If InStr(iSpcPos + 1, sText, " ") <> 0 Then  ' not last word
     sWords(UBound(sWords)) = _
        Mid$(sText, iSpcPos + 1, InStr(iSpcPos + 1, sText, " ") - iSpcPos)
   Else
     sWords(UBound(sWords)) = _
        Right$(sText, Len(sText) - iSpcPos) ' for last word
   End If
Loop

End Sub

