'Copyright 1993, Paul Bonner
'PC Magazine Visual Basic Utilities

DefInt A-Z
Option Explicit
'Changes in Titles.Click, GetFiles,SaveFiles, command1_Click (copy button)--search for BigTab or CHR$(9)
'also in Titles_Click

'------------------------------------
'Global Variables and Constants
'------------------------------------
Global Routines() As String   'array of routine names
Global Path$                  'application path
Global OldChoice As Integer   'previously selected routine
'Global BigTab$                'used for indexing sorted listbox
Global OldChoiceChanged As Integer 'flags change in current record
Global RecCounter As Integer  'tracks number of records
Global CRLF$                  'carriage return/line feed holder
Global Const CodeStart$ = "[Code]"  'used in LIBCODE.ASC to separate description and code
Global Const CodeEnd$ = "[Stop]"    'end of code marker for LIBCODE.ASC
'------------------------------------
'Module level variables used in file handling routines
'------------------------------------
Dim F As Integer               'file handle
Dim J As Integer               'file handle
Dim RecordNum As Integer       'identifies current record

Sub CenterDialog (TopForm As Form, BottomForm As Form)
Dim L, T
'------------------------------------
'Routine to center one form on top of another
'------------------------------------
L = BottomForm.Left + (BottomForm.Width - TopForm.Width) / 2
If L + TopForm.Width > Screen.Width Then L = Screen.Width - TopForm.Width
If L < 0 Then L = 0
TopForm.Left = L

T = BottomForm.Top + (BottomForm.Height - TopForm.Height) / 2
If T + TopForm.Height > Screen.Height Then T = Screen.Height - TopForm.Height
If T < 0 Then T = 0
TopForm.Top = T
End Sub

Sub CenterForm (F As Form)
'------------------------------------
'Routine to center a form on screen
'------------------------------------
F.Left = (Screen.Width - F.Width) / 2
F.Top = (Screen.Height - F.Height) / 2
End Sub

Sub Check_Changes ()
Dim SaveIt%
'------------------------------------
'If current record has changed and the listbox isn't empty
'give user a chance to save the file
'------------------------------------
If OldChoiceChanged And SelectForm.Titles.ListCount <> 0 Then
  SaveIt% = MsgBox("Save changes to current entry?", 68, "VB Code Librarian")
  If SaveIt% = 6 Then LibSave    'User clicked Yes button, so save it
  OldChoiceChanged = False
End If
End Sub

Sub CleanUpFiles ()
Dim X%
'------------------------------------
'Kill old backups
'Backup current files
'Make temp files current
'------------------------------------
On Error Resume Next
Kill Path$ + "LibIdx.Bak"
Kill Path$ + "LibCode.Bak"
Name Path$ + "Lib.IDX" As Path$ + "LibIdx.Bak"
Name Path$ + "LibCode.Asc" As Path$ + "LibCode.Bak"
Name Path$ + "Lib1.IDX" As Path$ + "Lib.IDX"
Name Path$ + "CodeFile.Tmp" As Path$ + "LibCode.Asc"
X% = DoEvents()
End Sub

Sub CopyOldRec ()
Dim Look$, C$
'------------------------------------
'Used to copy old contents of record to new file
'------------------------------------
Look$ = "[" & RecordNum & "]"
'------------------------------------
'Find index tag
'------------------------------------
Do While C$ <> Look$
Input #J, C$
Loop
'------------------------------------
'Read and copy old Description and Code
'------------------------------------
On Error GoTo ErrStop
Line Input #J, C$
Do While C$ <> CodeEnd$
Print #F, C$
Line Input #J, C$
Loop
'------------------------------------
'Backdoor for error-handling routine
'------------------------------------
ErrDoor:
'------------------------------------
'Add [Stop] tag at end of code
'------------------------------------
Print #F, CodeEnd$
Exit Sub

'------------------------------------
'Error handling routine
'------------------------------------
ErrStop:
Resume ErrDoor
End Sub

Sub DeleteRoutine ()
Dim X, Index, C$, Header$
'------------------------------------
'Exit if Titles listbox is empty
'------------------------------------
If SelectForm.Titles.ListCount = 0 Then Exit Sub
'------------------------------------
'Confirm user wants to delete
'------------------------------------
X = MsgBox("Are you sure that you want to delete the selected routine?", 68, "VB Code Librarian")
If X <> 6 Then Exit Sub
'------------------------------------
'Identify record to delete
'------------------------------------
'BT = InStr(SelectForm.Titles.Text, BigTab)
'Index = Val(Mid$(SelectForm.Titles.Text, BT + 1))
Index = SelectForm.Titles.ItemData(SelectForm.Titles.ListIndex)
'------------------------------------
'Save titles
'------------------------------------
F = FreeFile
Open Path$ + "Lib1.IDX" For Output Access Write As #F Len = 4096
'------------------------------------
'Decrease record counter by one
'------------------------------------
C$ = Trim(Str$(RecCounter - 1))
Print #F, C$
'------------------------------------
'Write out all titles except deleted one
'------------------------------------
For X = 1 To RecCounter
  If X <> Index Then Print #F, Routines(X)
Next
Close F
'------------------------------------
'Open input and output files for
'descriptions and code
'------------------------------------
F = FreeFile
Open Path$ + "CODEFILE.TMP" For Output Access Write As #F Len = 4096
J = FreeFile
Open Path$ + "LIBCODE.ASC" For Input As #J
'------------------------------------
'Loop through all records
'Save all except the deleted record
'Decrease the index number for all
'records above the current record.
'------------------------------------
For RecordNum = 1 To RecCounter
Select Case RecordNum
Case Is < Index
  Header$ = "[" & RecordNum & "]"
  Print #F, Header$
  CopyOldRec
Case Is = Index         'Deleted record, do nothing
Case Is > Index
  Header$ = "[" & RecordNum - 1 & "]"
  Print #F, Header$
  CopyOldRec
End Select
Next RecordNum
Close F
Close J
'------------------------------------
'Now clean up files
'------------------------------------
CleanUpFiles
'------------------------------------
'Clear titles listbox, repopulate, and select first item
'------------------------------------
SelectForm.Titles.Clear
GetFiles
If SelectForm.Titles.ListCount Then SelectForm.Titles.ListIndex = 0
End Sub

Sub GetFiles ()
Dim C$, X, Y
'------------------------------------
'Open Titles file
'------------------------------------
F = FreeFile
On Error GoTo IDXNotFound
Open Path$ + "Lib.IDX" For Input As F
'------------------------------------
'Input total records
'------------------------------------
Input #F, C$
RecCounter = Val(C$)
'------------------------------------
'Redimension Routines() array to hold
'titles of all records
'------------------------------------
ReDim Routines(RecCounter)
'------------------------------------
'Read record titles
'------------------------------------
For X = 1 To RecCounter
   Input #F, Routines(X)
'------------------------------------
'Add title to listbox, with BigTab$ and RecordNum appended
'------------------------------------
  SelectForm.Titles.AddItem Routines(X) '+ BigTab$ & X
  SelectForm.Titles.ItemData(SelectForm.Titles.NewIndex) = X
Next
Close F
BackDoor:
Exit Sub
'------------------------------------
'Error handling routine
'Give user chance to create a new
'index file if error trying to read old one
'------------------------------------
IDXNotFound:
Y = MsgBox(Path$ + "LIB.IDX Not Found. Create new library?", 20, "VB Code Librarian")
If Y <> 6 Then End
RecCounter = 0
Resume BackDoor
End Sub

Sub LibSave ()
Dim Index, Header$
'------------------------------------
'Create LIB1.IDX so that CleanUpFiles doesn't clobber index
'------------------------------------
Name Path$ + "Lib.IDX" As Path$ + "Lib1.IDX"
'------------------------------------
'Determine which record has been changed
'------------------------------------
'BT = InStr(SelectForm.Titles.List(OldChoice), BigTab)
'Index = Val(Mid$(SelectForm.Titles.List(OldChoice), BT + 1))
Index = SelectForm.Titles.ItemData(OldChoice)
'------------------------------------
'Save Descriptions & Code
'------------------------------------
     F = FreeFile
     Open Path$ + "CodeFile.Tmp" For Output Access Write As #F Len = 4096
     J = FreeFile
     Open Path$ + "LibCode.Asc" For Input As #J
     For RecordNum = 1 To RecCounter
	  Header$ = "[" & RecordNum & "]"
	  Print #F, Header$
'------------------------------------
'If RecordNum=the changed record, save the changed data
'otherwise copy the old data for this record
'------------------------------------
	  If RecordNum = Index Then
	       Print #F, SelectForm.Description.Text
	       Print #F, CodeStart$
	       Print #F, SelectForm.Code.Text
	       Print #F, CodeEnd$
	  Else
	      CopyOldRec
	  End If
     Next RecordNum
     Close J
     Close F
'------------------------------------
'Now clean up files
'------------------------------------
CleanUpFiles
End Sub

