Option Explicit

Function ConvertImageToMask (bmInfo As BITMAPINFO, hBitmapPixelData As Integer) As Integer
    Dim PixelBytesToCopy As Long
    Dim hMaskPixelData As Integer
    Dim lpBitmapPixelData As Long
    Dim lpMaskPixelData As Long
    Dim MaskPixelSelector As Integer
    Dim LastLine As Integer
    Dim LineCounter As Integer
    Dim ColumnCounter As Integer
    Dim LastColumn As Integer
    Dim PaddedLineWidth As Integer
    Dim BufferString As String
    Dim MemOffset As Long
    Dim TempChar As String * 1
    Dim RetValue As Integer
    Dim ColorTableIndex As Integer

    ' Copy the original bitmap pixels to another buffer,
    ' which will become the Mask pixel data.
    PixelBytesToCopy = bmInfo.bmiHeader.biSizeImage
    hMaskPixelData = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, PixelBytesToCopy)
    lpBitmapPixelData = GlobalLock(hBitmapPixelData)
    lpMaskPixelData = GlobalLock(hMaskPixelData)
    hmemcpy lpMaskPixelData, lpBitmapPixelData, PixelBytesToCopy
    lpBitmapPixelData = GlobalUnlock(hBitmapPixelData)
    lpMaskPixelData = GlobalUnlock(hMaskPixelData)

    MaskPixelSelector = GlobalHandleToSel(hMaskPixelData)
    LastLine = bmInfo.bmiHeader.biHeight - 1
    LastColumn = bmInfo.bmiHeader.biWidth
    PaddedLineWidth = ((LastColumn - 1) \ 4 + 1) * 4
    For LineCounter = 0 To LastLine
        BufferString = String$(PaddedLineWidth, Chr$(0))
        MemOffset = LineCounter * PaddedLineWidth
        RetValue = MemoryRead(MaskPixelSelector, MemOffset, ByVal BufferString, PaddedLineWidth)
        For ColumnCounter = 1 To LastColumn
            TempChar = Mid$(BufferString, ColumnCounter, 1)
            ColorTableIndex = Asc(TempChar)
            If (Asc(bmInfo.bmiColors(ColorTableIndex).rgbRed) <> 255) Or (Asc(bmInfo.bmiColors(ColorTableIndex).rgbBlue) <> 255) Or (Asc(bmInfo.bmiColors(ColorTableIndex).rgbGreen) <> 255) Then
                Mid$(BufferString, ColumnCounter, 11) = Chr$(0)
              Else
                Mid$(BufferString, ColumnCounter, 11) = Chr$(255)
              End If
            Next ColumnCounter
        RetValue = MemoryWrite(MaskPixelSelector, MemOffset, ByVal BufferString, PaddedLineWidth)
        Next LineCounter
    ConvertImageToMask = hMaskPixelData
    End Function

Function ConvertImageToSprite (bmInfo As BITMAPINFO, hBitmapPixelData As Integer) As Integer
    Dim PixelBytesToCopy As Long
    Dim hSpritePixelData As Integer
    Dim lpBitmapPixelData As Long
    Dim lpSpritePixelData As Long
    Dim SpritePixelSelector As Integer
    Dim LastLine As Integer
    Dim LineCounter As Integer
    Dim ColumnCounter As Integer
    Dim LastColumn As Integer
    Dim PaddedLineWidth As Integer
    Dim BufferString As String
    Dim MemOffset As Long
    Dim TempChar As String * 1
    Dim RetValue As Integer
    Dim ColorTableIndex As Integer

    ' Copy the original bitmap pixels to another buffer,
    ' which will become the Mask pixel data.
    PixelBytesToCopy = bmInfo.bmiHeader.biSizeImage
    hSpritePixelData = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, PixelBytesToCopy)
    lpBitmapPixelData = GlobalLock(hBitmapPixelData)
    lpSpritePixelData = GlobalLock(hSpritePixelData)
    hmemcpy lpSpritePixelData, lpBitmapPixelData, PixelBytesToCopy
    lpBitmapPixelData = GlobalUnlock(hBitmapPixelData)
    lpSpritePixelData = GlobalUnlock(hSpritePixelData)

    SpritePixelSelector = GlobalHandleToSel(hSpritePixelData)
    LastLine = bmInfo.bmiHeader.biHeight - 1
    LastColumn = bmInfo.bmiHeader.biWidth
    PaddedLineWidth = ((LastColumn - 1) \ 4 + 1) * 4
    For LineCounter = 0 To LastLine
        BufferString = String$(PaddedLineWidth, Chr$(0))
        MemOffset = LineCounter * PaddedLineWidth
        RetValue = MemoryRead(SpritePixelSelector, MemOffset, ByVal BufferString, PaddedLineWidth)
        For ColumnCounter = 1 To LastColumn
            TempChar = Mid$(BufferString, ColumnCounter, 1)
            ColorTableIndex = Asc(TempChar)
            If (Asc(bmInfo.bmiColors(ColorTableIndex).rgbRed) = 255) And (Asc(bmInfo.bmiColors(ColorTableIndex).rgbBlue) = 255) And (Asc(bmInfo.bmiColors(ColorTableIndex).rgbGreen) = 255) Then
                Mid$(BufferString, ColumnCounter, 1) = Chr$(0)
              End If
            Next ColumnCounter
        RetValue = MemoryWrite(SpritePixelSelector, MemOffset, ByVal BufferString, PaddedLineWidth)
        Next LineCounter
    ConvertImageToSprite = hSpritePixelData

    End Function

