Option Explicit

Type PALETTEENTRY
    peRed As String * 1
    peGreen As String * 1
    peBlue As String * 1
    peFlags As String * 1
    End Type

Type LOGPALETTE
    palVersion As Integer
    palNumEntries As Integer
    palPalEntry(255) As PALETTEENTRY
    End Type

Type ColorSteps
    iRed As Integer
    iGreen As Integer
    iBlue As Integer
    End Type

Global Const BLACK_BRUSH = 4
Global Const DEFAULT_PALETTE = 15
Global Const PC_RESERVED = &H1  '  palette index used for animation
Global Const CF_PALETTE = 9
Global Const DIB_RGB_COLORS = 0 '  color table in RGBTriples
Global Const DIB_PAL_COLORS = 1

Declare Function SelectPalette Lib "User" (ByVal hDC As Integer, ByVal hPalette As Integer, ByVal bForceBackground As Integer) As Integer
Declare Function RealizePalette Lib "User" (ByVal hDC As Integer) As Integer
Declare Function GetDC Lib "User" (ByVal hWnd As Integer) As Integer
Declare Function ReleaseDC Lib "User" (ByVal hWnd As Integer, ByVal hDC As Integer) As Integer
Declare Function CreateSolidBrush Lib "GDI" (ByVal crColor As Long) As Integer
Declare Function SelectObject Lib "GDI" (ByVal hDC As Integer, ByVal hObject As Integer) As Integer
Declare Function Rectangle Lib "GDI" (ByVal hDC As Integer, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer) As Integer
Declare Function DeleteObject Lib "GDI" (ByVal hObject As Integer) As Integer
Declare Function GetStockObject Lib "GDI" (ByVal nIndex As Integer) As Integer
Declare Function GetPaletteEntries Lib "GDI" (ByVal hPalette As Integer, ByVal wStartIndex As Integer, ByVal wNumEntries As Integer, lpPaletteEntries As PALETTEENTRY) As Integer
Declare Function SetPaletteEntries Lib "GDI" (ByVal hPalette As Integer, ByVal wStartIndex As Integer, ByVal wNumEntries As Integer, lpPaletteEntries As PALETTEENTRY) As Integer
Declare Function CreatePalette Lib "GDI" (lpLogPalette As LOGPALETTE) As Integer
' This function isn't used in this program, but it's a member of the family:
' Declare Sub AnimatePalette Lib "GDI" (ByVal hPalette As Integer, ByVal wStartIndex As Integer, ByVal wNumEntries As Integer, lpPaletteColors As PALETTEENTRY)

Global ColorSelected As Long
Global hSystemPalette As Integer
Global hCurrentPalette As Integer
Global CurrentPaletteEntry As PALETTEENTRY
Global NewPaletteEntry As PALETTEENTRY
Global PaletteEntries(256) As PALETTEENTRY

Sub ConstructPaletteFromColorTable (ColorTable() As RGBQUAD, LogicalPalette As LOGPALETTE)
    Dim Counter As Integer
    Dim TempString As String

    TempString = ""
    For Counter = 0 To 255
	LogicalPalette.palPalEntry(Counter).peRed = ColorTable(Counter).rgbRed
	LogicalPalette.palPalEntry(Counter).peGreen = ColorTable(Counter).rgbGreen
	LogicalPalette.palPalEntry(Counter).peBlue = ColorTable(Counter).rgbBlue
	LogicalPalette.palPalEntry(Counter).peFlags = Chr$(0)
	Next Counter
    LogicalPalette.palVersion = &H300
    LogicalPalette.palNumEntries = 256
    End Sub

