Attribute VB_Name = "PuzzleCode"
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long

Declare Function GetDesktopWindow Lib "user32" () As Long

Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Public Const SRCCOPY = &HCC0020 'Constant used to copy data with BitBlt

'Constants used to set window as topmost
Public Const HWND_TOPMOST = -1
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_SHOWWINDOW = &H40

Public EventHappens As Integer 'Variable used to realize when an event has happened
Public HorizontalSize As Integer 'Width of blocks being moved
Public VerticalSize As Integer 'Height of blocks being moved
Sub DoSaver()

With PuzzleForm
    
    DeskhWnd& = GetDesktopWindow() 'Get hWnd of Desktop
    DeskhDC& = GetDC(DeskhWnd&) 'Get hDC of Desktop
    
    .Width = Screen.Width 'get correct width
    .Height = Screen.Height 'get correct height
    .ScaleMode = 3 'Set ScaleMode to Pixels
    X = BitBlt(.hdc, 0, 0, .ScaleWidth, .ScaleHeight, DeskhDC&, 0, 0, SRCCOPY) 'Copy image of screen to form
    
    X = SetCursorPos(.ScaleWidth + 1, .ScaleHeight + 1) 'Get cursor out of sight
    
    .Visible = True 'Set Form visible
    DoEvents 'Allow window to be displayed
    
    X = SetWindowPos(.hWnd, HWND_TOPMOST, 0, 0, .ScaleWidth, .ScaleHeight, SWP_NOACTIVATE Or SWP_SHOWWINDOW) 'Make form topmost window
    
    HorizontalSize = .ScaleWidth / 16 'Divide the screen horizontally
    VerticalSize = .ScaleHeight / 12 'Divide the screeen vertically
    
    .Timer1.Enabled = True 'Enable timer to perform display
    
    EventHappens = False 'Set to false incase an event has already been triggered
    Do Until EventHappens
        
        DoEvents 'Wait for any events to process
        
    Loop
    
    X = ReleaseDC(DeskhWnd&, DeskhDC&) 'Release handle on desktop

    End 'End Screen Saver
    
End With

End Sub

Sub Main()
    
    Select Case LCase$(Left$(Command$, 2)) 'Select course of operation based on the first two letters on command line
        
        Case "/c" 'Control Switch
        
            CR$ = Chr$(13) + Chr$(10) 'Carrage Return
            
            'Create Message for Display
            Message$ = "Puzzle Screen Saver for Windows95 version 1.0" + CR$
            Message$ = Message$ + "Written as a Visual Basic 4 32-bit screen saver example." + CR$
            Message$ = Message$ + "By Ted Schundler" + CR$ + CR$
            Message$ = Message$ + "Settings not available."
    
            MsgBox Message$, 64, "Puzzle Screen Saver" 'Display message in an MsgBox with the vbInformation icon.
        
        Case "/p" 'Preview Switch
    
           ShowPreview 'Call Subroutine to display preview graphic
    
        Case "/s" 'Show Switch
        
            DoSaver 'Call routine to do screen saver
        
    End Select

End Sub


'This Subroutine is used to show the Windows95
'Preview Display. This is not animated like most
'previews, because I have yet to figure out how
'to detect when the Screen Saver should unload.
'This works O.K. and it gets rid of the blank
'preview display you would see otherwise.
Sub ShowPreview()

    Load PuzzleForm 'Load form so we can access the picture
    For I = 1 To 200: DoEvents: Next 'Delay for everything to load
    
    Preview_hWnd& = Val(Right$(Command$, Len(Command$) - 3)) 'Get hWnd of preview display from command line
    Preview_hDC& = GetDC(Preview_hWnd&) 'Get DC for Preview Display
    
    X = BitBlt(Preview_hDC&, 0, 0, 160, 120, PuzzleForm.Picture1.hdc, 0, 0, SRCCOPY) 'BitBlt image onto Preview
    
    X = ReleaseDC(Preview_hWnd&, Preview_hDC&) 'Free resurces from preview display hDC

    For I = 1 To 200: DoEvents: Next 'Delay for everything to load
    End 'Close program

End Sub


