Attribute VB_Name = "WinHWND"
'**************************************************
' LodLe DodLe Software                  WinHWND
' -------------------------------       =======
' HTTP://USERS.AOL.COM/LODLEDODLE
'
' WinHWND: For retrieving Window Information
'
' Last Updated: 8/23/96
' Author: Gil Birman
' Notes: Please contact HapPpy1@aol.com if you
'        Find any errors or bugs in this code, or
'        if you have anything to add or make the
'        code more efficient. Send comments and
'        suggestions to: LodLeDodLe@aol.com.
'**************************************************
   
   ' API Declarations
   #If Win32 Then
      Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
      Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
      Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
      Private Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
      Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
      Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
      Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
      Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
      Private Declare Function GetWindowWord Lib "user32" (ByVal hWnd As Long, ByVal nIndex As Long) As Integer
      Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Integer, ByVal lParam As Any) As Long
      'Private Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hWnd As Long, ByVal lpString As String) As Long
      'Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
      Private Declare Function WindowFromPointXY Lib "user32" Alias "WindowFromPoint" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
   #Else
      Private Declare Function FindWindow Lib "User" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Integer
      Private Declare Function GetClassName Lib "User" (ByVal hWnd As Integer, ByVal lpClassName As String, ByVal nMaxCount As Integer) As Integer
      Private Declare Sub GetCursorPos Lib "User" (lpPoint As Long)
      Private Declare Function GetFocus Lib "User" () As Integer
      Private Declare Function GetModuleFileName Lib "Kernel" (ByVal hModule As Integer, ByVal lpFileName As String, ByVal nSize As Integer) As Integer
      Private Declare Function GetParent Lib "User" (ByVal hWnd As Integer) As Integer
      Private Declare Function GetWindow Lib "User" (ByVal hWnd As Integer, ByVal wCmd As Integer) As Integer
      Private Declare Function GetWindowLong Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer) As Long
      Private Declare Function GetWindowText Lib "User" (ByVal hWnd As Integer, ByVal lpString As String, ByVal aint As Integer) As Integer
      Private Declare Function GetWindowWord Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer) As Integer
      Private Declare Function SendMessage Lib "User" (ByVal hWnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, lParam As Any) As Long
      'Private Declare Sub SetWindowText Lib "User" (ByVal hWnd As Integer, ByVal lpString As String)
      'Private Declare Sub SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer)
      Private Declare Function WindowFromPoint Lib "User" (ByVal ptScreen As Any) As Integer
   #End If
   
   ' API Types
   #If Win32 Then
      Private Type POINTAPI
         X As Long
         Y As Long
      End Type
   #End If
   
   ' GetWindowWord Constants
   Private Const GWW_HINSTANCE = (-6)
   Private Const GWW_ID = (-12)
   Private Const GWL_STYLE = (-16)

   ' GetWindow Constants
   Private Const GW_CHILD = 5
   Private Const GW_HWNDFIRST = 0
   Private Const GW_HWNDLAST = 1
   Private Const GW_HWNDNEXT = 2
   Private Const GW_HWNDPREV = 3
   Private Const GW_MAX = 5
   Private Const GW_OWNER = 4
'****UNUSED Declares and Constants have been commented out*****

'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Finds all the child windows within a
'              given window.
'
' Syntax:
'     GetChildArray(ChildArray(), hParent)
'        - ChildArray(): Array to place handles into
'        - hParent: Handle of the Parent Window
'
' Returns:
'    Number of child windows found
'
' Uses: n/a
'==================================================
#If Win32 Then
Public Function GetChildArray(ChildArray() As Long, ByVal hParent As Long) As Long
#Else
Public Function GetChildArray(ChildArray() As Integer, ByVal hParent As Integer) As Integer
#End If
      ' Declares
   #If Win32 Then
      Dim hChild As Long         ' Handle of the Child
      Dim Temp(256) As Long   ' Temporary array
   #Else
      Dim hChild As Integer      ' Handle of the Child
      Dim Temp(256) As Integer   ' Temporary array
   #End If
   Dim i As Integer        ' Index counter
   '
   ' Make sure a Window handle was specified, if not, Return False
   '
   If hParent = 0 Then
      GoTo Return_False
   End If
   
   '
   ' Get the Handle of one of the Child Windows
   '
   hChild = GetWindow(hParent, GW_CHILD)
   
   '
   ' Loop until we find the Child Window
   ' with the specified Class Name and
   ' Index.
   '
   While hChild
      '
      ' Add to array
      '
      Temp(i) = hChild
      
      ' Find the next child window's handle
      hChild = GetWindow(hChild, GW_HWNDNEXT)
      
      ' Increase counter
      i = i + 1
   Wend
   
   ' If no child windows were found,
   ' return false, then exit
   If i = 0 Then GoTo Return_False
   
   ' Fill array
   #If Win32 Then
      ReDim ChildArray(i - 1) As Long
   #Else
      ReDim ChildArray(i - 1) As Integer
   #End If
   For i = 0 To i - 1
      ChildArray(i) = Temp(i)
   Next i
   
   ' Return number of children
   GetChildArray = i
   
   Exit Function
Return_False:
   GetChildArray = 0
   Exit Function
End Function
'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Returns number of children within a
'              given window.
'
' Syntax:
'     GetChildCount(hWnd)
'     - hWnd: Handle of the Window
'
' Returns:
'    Number of child windows found
'
' Uses: n/a
'==================================================
#If Win32 Then
Public Function GetChildCount(ByVal hWnd As Long) As Long
#Else
Public Function GetChildCount(ByVal hWnd As Integer) As Integer
#End If
      ' Declares
   #If Win32 Then
      Dim hChild As Long      ' Handle of the Child
   #Else
      Dim hChild As Integer      ' Handle of the Child
   #End If
   Dim i As Integer        ' Index counter
   
   '
   ' Make sure a Window handle was specified, if not, Return False
   '
   If hWnd = 0 Then
      GoTo Return_False
   End If
   
   '
   ' Get the Handle of one of the Child Windows
   '
   hChild = GetWindow(hWnd, GW_CHILD)
   
   '
   ' Loop until we find the Child Window
   ' with the specified Class Name and
   ' Index.
   '
   While hChild
      ' Find the next child window's handle
      hChild = GetWindow(hChild, GW_HWNDNEXT)
      
      ' Increase counter
      i = i + 1
   Wend
   
   ' Return number of children
   GetChildCount = i
   
   Exit Function
Return_False:
   GetChildCount = 0
   Exit Function
End Function


'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Returns the File Name of the given
'              Window Module.
'
' Syntax:
'     GetParentWindow(hWnd)
'     - hWnd: Handle of the Window
'
' Returns:
'    The Path and File Name of the Window Module
'
' Uses: n/a
'==================================================
#If Win32 Then
Public Function GetFileName(ByVal hWnd As Long) As String
#Else
Public Function GetFileName(ByVal hWnd As Long) As String
#End If
   ' Declares
   #If Win32 Then
      Dim sModuleFileName As String * 100
      Dim hInstance, Ret As Long
   #Else
      Dim sModuleFileName As String * 100
      Dim hInstance, Ret As Integer
   #End If
   
   ' Get window instance:
   hInstance = GetWindowWord(hWnd, GWW_HINSTANCE)
   
   ' Get module file name:
   Ret = GetModuleFileName(hInstance, sModuleFileName, 100)
   
   ' Return Value
   GetFileName = Left(sModuleFileName, Ret)
End Function

'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Finds the handle of the Parent
'              Window of the specified window.
'
' Syntax:
'     GetParentWindow(hWnd)
'     - hWnd: Handle of the window
'
' Returns:
'    The hWnd (Handle) of the Parent Window
'
' Uses: n/a
'==================================================
#If Win32 Then
Public Function GetParentWindow(ByVal hWnd As Long) As Long
#Else
Public Function GetParentWindow(ByVal hWnd As Integer) As Integer
#End If

   ' Get handle of parent window
   GetParentWindow = GetParent(hWnd)
End Function


'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Finds the Child Window which is
'              TopMost
'
' Syntax:
'     GetTopChild(hWnd)
'     - hWnd: The Handle of the Window.
'
' Returns:
'    Handle of the child window
'
' Uses: n/a
'==================================================
#If Win32 Then
Function GetTopChild(ByVal hWnd As Long) As Long
#Else
Function GetTopChild(ByVal hWnd As Integer) As Integer
#End If
   GetTopChild = GetWindow(hWnd, GW_CHILD)
End Function

'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Finds the Handle of the Window the
'              mouse pointer is over
'
' Syntax:
'  hWndOver()
'
' Returns:
'    The hWnd (Handle) of the Window which the
'    mouse pointer is over
'
' Uses: n/a
'==================================================
#If Win32 Then
Public Function hWndOver() As Long
#Else
Public Function hWndOver() As Integer
#End If

   #If Win32 Then
      ' Declares
      Dim pt32 As POINTAPI
      Dim ptx As Long
      Dim pty As Long
   
      Call GetCursorPos(pt32)               ' Get cursor position
      ptx = pt32.X
      pty = pt32.Y
      hWndOver = WindowFromPointXY(ptx, pty)    ' Get window cursor is over
   #Else
      ' Declares
      Dim ptCursor As Long
      
      Call GetCursorPos(ptCursor)               ' Get cursor position
      hWndOver = WindowFromPoint(ptCursor)       ' Get window cursor is over
   #End If
End Function


'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Finds the Class Name of a Window.
'
' Syntax:
'     GetWindowClassName(hWindow, sClassName)
'     - hWindow: The Handle of the Window.
'
' Returns:
'    The Class Name of the Specified Window
'
' Uses: n/a
'==================================================
#If Win32 Then
Public Function GetWindowClassName(ByVal hWindow As Long) As String
#Else
Public Function GetWindowClassName(ByVal hWindow As Integer) As String
#End If
   ' Declares
   #If Win32 Then
      Dim sClassName As String * 100
      Dim Ret As Long
   #Else
      Dim sClassName As String * 100
      Dim Ret As Integer
   #End If
   
   '
   ' Get the Window's Class Name
   '
   Ret = GetClassName(hWindow, sClassName, 100)
   
   '
   ' Return value to calling routine
   '   - r%: Length of Class Name String
   '   - sClassName: The Class Name
   '
   GetWindowClassName = Trim$(Left(sClassName, Ret))
End Function
               

'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Finds the handle of a child
'              window.
'
' Syntax:
'     FindChildByClass(hParent, strClassName, [nIndex])
'        - hParent: Handle of the Parent Window
'        - strClassName: ClassName of the child window
'        - nIndex: If there are more than one child window
'                                  within the specified parent which
'                                  share the same class name, nIndex
'                                  specifies which window, ussually in
'                                  order of appearance to find. (OPTIONAL)
'
' Returns:
'
'    A.) The handle of the Child Window -
'        if it was found.
'             OR
'    B.) 0 - If...
'            a)The Child Window with the
'               specified Class and/or Index
'               was not found, OR
'            b)One of the perimeters was invalid
'
' Uses: GetWindowClassName
'==================================================
#If Win32 Then
Public Function FindChildByClass(ByVal hParent As Long, ByVal sClassName As String, Optional ByVal nIndex) As Long
#Else
Public Function FindChildByClass(ByVal hParent As Integer, ByVal sClassName As String, Optional ByVal nIndex) As Integer
#End If
   ' Declares
   #If Win32 Then
      Dim hChild As Long      ' Handle of the Child
   #Else
      Dim hChild As Integer   ' Handle of the Child
   #End If
   Dim i As Integer           ' Index counter

   '
   ' Check to see if Index was specified, if not
   ' set to 1.
   '
   ' If index was specified, make sure it is more
   ' than 0, if not, exit and Return False
   '
   If IsMissing(nIndex) Then
      nIndex = 1
   ElseIf nIndex < 1 Then
      Exit Function
   End If
   
   '
   ' Get the Handle of one of the Child Windows
   '
   hChild = GetWindow(hParent, GW_CHILD)
   
   '
   ' Loop until we find the Child Window
   ' with the specified Class Name and
   ' Index.
   '
   While i < nIndex And hChild
      ' Increase counter if specified
      ' class name is found.
      If GetWindowClassName(hChild) = sClassName Then
         i = i + 1   ' Increase counter
      End If
      
      ' Find the next child window's handle
      If i < nIndex Then
         hChild = GetWindow(hChild, GW_HWNDNEXT)
      End If
   Wend
   
   ' Success!
   ' Return the handle of the child window
   FindChildByClass = hChild
   Exit Function
End Function


'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Finds the handle of a child window
'              according to it's window text.
'
' Syntax:
'     FindChildByTitle(hParent, sWindowText, [nIndex])
'        - hParent: Handle of the Parent Window
'        - sWindowText: Window Text of the child window
'        - nIndex: If there are more than one child window
'                                  within the specified parent which
'                                  share the same class name, nIndex
'                                  specifies which window, ussually in
'                                  order of appearance to find. (OPTIONAL)
'
' Returns:
'
'    A.) The handle of the Child Window -
'        if it was found.
'             OR
'    B.) 0 - If...
'            a)The Child Window with the
'               specified Window text and/or Index
'               was not found, OR
'            b)One of the perimeters was invalid
'
' Uses: GetWindowClassName
'==================================================
#If Win32 Then
Public Function FindChildByTitle(ByVal hParent As Long, ByVal sWindowText As String, Optional ByVal nIndex) As Long
#Else
Public Function FindChildByTitle(ByVal hParent As Integer, ByVal sWindowText As String, Optional ByVal nIndex) As Integer
#End If
   ' Declares
   #If Win32 Then
      Dim hChild As Long      ' Handle of the Child
   #Else
      Dim hChild As Integer   ' Handle of the Child
   #End If
   Dim i As Integer              ' Index counter

   '
   ' Check to see if Index was specified, if not
   ' set to 1.
   '
   ' If index was specified, make sure it is more
   ' than 0, if not, exit and Return False
   '
   If IsMissing(nIndex) Then
      nIndex = 1
   ElseIf nIndex < 1 Then
      Exit Function
   End If
   
   '
   ' Get the Handle of first Child Window
   '
   hChild = GetWindow(hParent, GW_CHILD)
   
   '
   ' Loop until we find the Child Window
   ' with the specified Window Text and
   ' Index.
   '
   While i < nIndex And hChild
      ' If the Window Text is what we're
      ' looking for, increase counter
      If WindowText(hChild) = sWindowText Then
         i = i + 1
      End If
      
      ' Find the next child window's handle
      If i < nIndex Then
         hChild = GetWindow(hChild, GW_HWNDNEXT)
      End If
   Wend
   
   ' Success!
   ' Return the handle of the child window
   FindChildByTitle = hChild
   Exit Function
End Function

'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Returns the text of the specified
'              Window.
'
' Syntax:
'     WindowText(hWnd)
'     - hWnd: Handle of the window you're
'                looking for
'
' Returns:
'    The Window Text of the specified window
'
' Uses: n/a
'==================================================
#If Win32 Then
Public Function WindowText(ByVal hWnd As Long) As String
#Else
Public Function WindowText(ByVal hWnd As Integer) As String
#End If

   ' Declare Return Variable
   #If Win32 Then
      Dim Ret As Long
   #Else
      Dim Ret As Integer
   #End If
   Dim sWindowText As String * 100
   
   ' Get the Window's text
   Ret = GetWindowText(hWnd, sWindowText, 100)
   WindowText = Left(sWindowText, Ret)
End Function




'==================================================
' Author: Gil Birman (LodLe DodLe Software)
' ------
'
' Description: Determines whether a window has a ClassName.
'              You can use this to determine whether
'              a window exists (given that the
'              specified window should have a classname)
'
' Syntax:
'     GetWindowClassName(hWnd)
'     - hWnd: The Handle of the Window.
'
' Returns:
'    True if Window has a ClassName
'
' Uses: GetWindowClassName
'==================================================
#If Win32 Then
Public Function HasClassName(ByVal hWnd As Long) As Boolean
#Else
Public Function HasClassName(ByVal hWnd As Integer) As Boolean
#End If
   HasClassName = Len(GetWindowClassName(hWnd))
End Function

