VERSION 2.00
Begin Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   795
   ClientLeft      =   1950
   ClientTop       =   2295
   ClientWidth     =   1425
   Height          =   1200
   Left            =   1890
   LinkTopic       =   "Form1"
   ScaleHeight     =   795
   ScaleWidth      =   1425
   Top             =   1950
   Width           =   1545
End
Option Explicit
'Copyright (c) 1993 James Talbot, you may do anything you want with this source code except
'restrict anyone else's freedom to do anything they want with it.
'THE AUTHOR MAKES NO WARRANTY OF FITNESS FOR ANY PURPOSE WHATSOEVER,
'NOR ACCEPTS ANY RESPONSIBILTY FOR ANY RESULTS OF ANY USE OF THIS SOURCE CODE
'
'Note: the declarations for the profile functions in the VB "WIN31API.HLP" are wrong!
'(inconsistant ByVal's and some parameter names make no sense)the ones in the ICONWRKS sample
'are ok, as are these
Declare Function WriteProfileString Lib "Kernel" (ByVal lpszSection As String, ByVal lpszEntry As String, ByVal lpszString As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpzSection As String, ByVal lpszEntry As String, ByVal lpszString As String, ByVal lplFileName As String) As Integer

Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpzSection As String, ByVal lpszEntry As String, ByVal lpszDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer

'The next function could be used to get a number directly from an .INI, but in this example
'I'm getting a string and using Val() to convert it to a number when I need to since I want
'to use the entry as both a string and a number.
Declare Function GetPrivateProfileInt Lib "Kernel" (ByVal lpzSection As String, ByVal lpszEntry As String, ByVal nDefault As Integer, ByVal lpFileName As String) As Integer

'Below was an excerpt from the Windows SDK help file, but after checking the copyright
'I found that "No PART of this manual may be reproduced or tranmited" (CAPS mine)
'But what it said was basicly, was that one shouldn't cluter up the WIN.INI with things that
'are for your programs exclusive use. A quick look at WIN.INI will show that
'Microsoft does not follow this advice (or hardly anyone else, including AOL and Lotus,
'here's somthing really weird, I have only AmiPro from Lotus, and it has nearly
'a DOZEN private .INI files, but still, it's dialog editor puts stuff in WIN.INI!)
'But perhaps we should be nice. This example does write to the [extensions] section of WIN.INI
'since it's info we want used by by other programs (file manager and program manager at least)
'but it stores it's execution count in a private ini. This is however, a borderline case,
'since we are saving only one item, it might not really be worth creating a file for it,
'and one more line in WIN.INI might not be so bad, for example the Windows charmap utility
'writes one line to WIN.INI.

Sub Form_Load ()
    Dim retval As Integer               'used for API function return
    Dim msg As String                   'buffer for data sent to MsgBox
    Dim ReturnBuffer As String          'string returned by GetPrivateProfileString
    Dim ThisProgram As String           'the complete pathname to this program
    Dim INIfile As String               'name + .INI (no path)
    Dim sTemp As String                 'temporary work space
    
    ReturnBuffer = String$(80, 0)       'alocate some space for our string, API functions can't
                                        'use VB's strings directly, they just expect an area of memory
                                        'one could also use a fixed length string eg; dim S as string * 80
    ThisProgram = App.Path & "\" & App.EXEName & ".EXE"
    INIfile = App.EXEName & ".INI"      'using the App object to get name/path of this prog.
    
    'the next statment will add an entry to the [extensions] section of WIN.INI that will
    'associate this program with the extension .XYZ, to try it, make an .EXE of this program,
    'run it, create a file (contents don't matter) with the extension .XYZ, then double click
    'the file in File Manager, that should run this program. Also take a look at WIN.INI
    'one can remove or comment out the next line to avoid messing with WIN.INI
    retval = WriteProfileString("Extensions", "xyz", ThisProgram & " ^.XYZ  [This Was Just A Test]")
    
    'check for prev. instance(s), (I don't know how to count them if more than one, I hope
    'that isn't what was originaly asked for)
    If App.PrevInstance Then
        msg = "There is at least one instance of " & App.EXEName & " already running" & Chr$(13) & Chr$(13)
    Else
        msg = "This is the only instance of " & App.EXEName & " running" & Chr$(13) & Chr$(13)
    End If

    'get the current run count from our .INI file
    retval = GetPrivateProfileString("History", "Count", "0", ReturnBuffer, Len(ReturnBuffer), INIfile)
    'the API functions return a null (Chr$(0)) terinated string, which VB doesn't use
    'so I'm extracting only the usable stuff (I had all kinds of trouble before doing this)
    'GetPrivate... returns the number of characters read (excluding the null) so using
    'Left$(ReturnBuffer, retval) gets us the usable portion
    ReturnBuffer = Left$(ReturnBuffer, retval)

    If ReturnBuffer = "0" Then
        msg = msg & "This is the first time this program has been run." & Chr$(13)
        msg = msg & "(Or else there was a problem reading INI file" & Chr$(13)
        msg = msg & "and we are using the default return value)" & Chr$(13) & Chr$(13)
    Else
        If ReturnBuffer = "11" Then
            sTemp = "11'th"               'fixes 11'st that the Select Case would make
        Else
            sTemp = Right$(ReturnBuffer, 1)
            Select Case sTemp
                Case "0", "4", "5", "6", "7", "8", "9"
                    sTemp = ReturnBuffer & "'th "
                Case "1"
                    sTemp = ReturnBuffer & "'st "
                Case "2"
                    sTemp = ReturnBuffer & "'nd "
                Case "3"
                    sTemp = ReturnBuffer & "'rd "
            End Select
        End If
        msg = msg & "This is the " & sTemp & " time this program has run" & Chr$(13) & Chr$(13)
    End If

    'update the execution count for next time
    'convert to number, add 1, convert to string, trim any extraneous spaces
    sTemp = Trim$(Str$(Val(ReturnBuffer) + 1))
    If WritePrivateProfileString("History", "Count", sTemp, INIfile) = 0 Then
        MsgBox "Bummers! WritePrivateProfileString returned an error", 48
    End If
    
    
    'tell the user what is going on
    msg = msg & "Current working directory is:" & Chr$(13) & CurDir$ & Chr$(13) & Chr$(13)
    If Command = "" Then        ' If no command line.
        msg = msg & "There is currently no command-line string."
    Else                        ' Put command line into message. if file asociations were used
                                ' there will be stuff in the commandline
        msg = msg & "The command-line string is:" & Chr$(13) & Command
    End If
    MsgBox msg, 0, ThisProgram  ' Display message.
    End                         ' quit the program
    'note that all this seems to happen before the form is shown, thus we never see the form,
    'just the MsgBoxes
End Sub

