'===================
'==  COMMON.BAS   ==
'===================
Option Explicit
DefInt A-Z

Global Const MODAL = 1
Global Const DEFAULT = 0
Global Const HOURGLASS = 11
Global Const NORMAL = 0
Global Const MINIMIZED = 1
Global Const MAXIMIZED = 2
Global Const APOS = "'"

Global CrLf As String
Global Message$, Title$, Style As Integer, Answer As Integer
Global CommonDir$
Global ds As dynaset

'keep wait.frm on top during init
Declare Sub SetWindowPos Lib "User" (ByVal hWnd As Integer, ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer)

Sub CenterForm (frm As Form)
    
  If frm.WindowState <> MINIMIZED Then
    frm.Move (Screen.Width - frm.Width) \ 2, (Screen.Height - frm.Height) \ 2
  End If

End Sub

Function CriticalErrorHandler (ErrorNum As Long)

  On Error GoTo DisplayMessage
  Error ErrorNum
  Exit Function

DisplayMessage:
  MsgBox "Error: " & Err & Chr$(10) & Error$
  Call ProgramShutDown
  Exit Function

End Function

Sub InitFormDataControls (f As Form)

  Dim i As Integer, x As Integer, y As Integer
  Dim dta As String

  For i = 0 To f.Controls.Count - 1
    If TypeOf f.Controls(i) Is Data Then
      dta = Trim$(LCase$(f.Controls(i%).DatabaseName))
      If Len(dta) Then
        x = 0                          'parses the '\'
        y = InStr(dta, "\")
        While y
          x = y
          y = InStr(x + 1, dta, "\")
        Wend
        dta = CommonDir$ + Mid$(dta, x + 1)
      End If
      f.Controls(i).DatabaseName = Trim$(dta)
    End If
  Next
  
End Sub

Sub ProgramShutDown ()

  Dim rc As Integer

  rc = UnloadAllForms()
  Close
  End
  
End Sub

Function UnloadAllForms () As Integer
   
  Dim i As Integer
  
  On Local Error Resume Next
  For i = Forms.Count - 1 To 0 Step -1
    Unload Forms(i)
  Next
  UnloadAllForms = True

End Function

