Attribute VB_Name = "DIALOGS1"
Rem Demo for accessing Win 3.1 and Win32 Common Dialogs
Rem Originally Demo for accessing Win 3.1 Common Dialogs
Rem Author: Costas Kitsos, CIS 73667,1755
Rem Revision: 1.00.00, July 4 1992

Rem Updated for VB4/Win32 By Pat Chefalo 73457,3603
Rem Revision: 2.00.00, February 26, 1996
Rem Thanks to Bruce McKinney and "Hard Core Visual Basic" for the solution
Rem to the Fonts choosing Win32 problems

DefInt A-Z

' File Open/Save structures and declarations *****************************


#If Win32 Then
Type OPENFILENAME
        lStructSize As Long         'Same
        hwndOwner As Long           'Was Integer
        hInstance As Long           'Was Integer
        lpstrFilter As String       'Was Long
        lpstrCustomFilter As String 'Was Long
        nMaxCustFilter As Long      'Same
        nFilterIndex As Long        'Same
        lpstrFile As String         'Was Long
        nMaxFile As Long            'Same
        lpstrFileTitle As String    'Was Long
        nMaxFileTitle As Long       'Same
        lpstrInitialDir As String   'Was Long
        lpstrTitle As String        'Was Long
        flags As Long               'Same
        nFileOffset As Integer      'Same
        nFileExtension As Integer   'Same
        lpstrDefExt As String       'Was Long
        lCustData As Long           'Same
        lpfnHook As Long            'Same
        lpTemplateName As String    'Was long
End Type
#Else
Type OPENFILENAME
     lStructSize As Long
     hwndOwner As Integer
     hInstance As Integer
     lpstrFilter As Long
     lpstrCustomFilter As Long
     nMaxCustFilter As Long
     nFilterIndex As Long
     lpstrFile As Long
     nMaxFile As Long
     lpstrFileTitle As Long
     nMaxFileTitle As Long
     lpstrInitialDir As Long
     lpstrTitle As Long
     flags As Long
     nFileOffset As Integer
     nFileExtension As Integer
     lpstrDefExt As Long
     lCustData As Long
     lpfnHook As Long
     lpTemplateName As Long
End Type
#End If

#If Win32 Then
Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function GetFileTitle Lib "comdlg32.dll" Alias "GetFileTitleA" (ByVal lpszFile As String, ByVal lpszTitle As String, ByVal cbBuf As Integer) As Integer
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
#Else
Declare Function GetOpenFileName Lib "COMMDLG.DLL" (pOpenfilename As OPENFILENAME) As Integer
Declare Function GetSaveFileName Lib "COMMDLG.DLL" (pOpenfilename As OPENFILENAME) As Integer
Declare Function GetFileTitle Lib "COMMDLG.DLL" (ByVal FName As String, ByVal Title As String, Size As Integer)
#End If

Public Const OFN_ALLOWMULTISELECT = &H200      'See Help Note for LFN Behavior
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_EXPLORER = &H80000            'Windows 95 Only
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_LONGNAMES = &H200000          'Windows 95 Only
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_NODEREFERENCELINKS = &H100000 'Windows 95 Only
Public Const OFN_NOLONGNAMES = &H40000         'Not Referenced in Help!
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_READONLY = &H1
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0
Public Const OFN_SHOWHELP = &H10

'ChooseColor structure and function declarations *************************

#If Win32 Then
Type CHOOSECOLOR
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        rgbResult As Long
        lpCustColors As Long
        flags As Long
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type
#Else
Type CHOOSECOLOR
     lStructSize As Long
     hwndOwner As Integer
     hInstance  As Integer
     rgbResult As Long
     lpCustColors As Long
     flags As Long
     lCustData As Long
     lpfnHook As Long
     lpTemplateName As Long
End Type
#End If

#If Win32 Then
Declare Function CHOOSECOLOR Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long
#Else
Declare Function CHOOSECOLOR Lib "COMMDLG.DLL" Alias "ChooseColor" (pChoosecolor As CHOOSECOLOR) As Integer
#End If

Public Const CC_ENABLEHOOK = &H10
Public Const CC_ENABLETEMPLATE = &H20
Public Const CC_ENABLETEMPLATEHANDLE = &H40
Public Const CC_FULLOPEN = &H2
Public Const CC_PREVENTFULLOPEN = &H4
Public Const CC_RGBINIT = &H1
Public Const CC_SHOWHELP = &H8

' FONT STUFF
Global Const LF_FACESIZE = 32

#If Win32 Then
Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(LF_FACESIZE) As Byte
End Type
#Else
Type LOGFONT
    lfHeight As Integer
    lfWidth As Integer
    lfEscapement As Integer
    lfOrientation As Integer
    lfWeight As Integer
    lfItalic As String * 1
    lfUnderline As String * 1
    lfStrikeOut As String * 1
    lfCharSet As String * 1
    lfOutPrecision As String * 1
    lfClipPrecision As String * 1
    lfQuality As String * 1
    lfPitchAndFamily As String * 1
    lfFaceName As String * LF_FACESIZE
End Type
#End If

Global Const LOGPIXELSY = 90    '  Logical pixels/inch in Y
Public Const CCHDEVICENAME = 32
Public Const CCHFORMNAME = 32

#If Win32 Then
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
#Else
Declare Function GetDeviceCaps Lib "GDI" (ByVal hdc As Integer, ByVal nIndex As Integer) As Integer
#End If

'ChooseFont structure and function declarations *************************

#If Win32 Then
Type ChooseFont
        lStructSize As Long
        hwndOwner As Long          '  caller's window handle
        hdc As Long                '  printer DC/IC or NULL
        lpLogFont As Long          '  ptr. to a LOGFONT struct
        iPointSize As Long         '  10 * size in points of selected font
        flags As Long              '  enum. type flags
        rgbColors As Long          '  returned text color
        lCustData As Long          '  data passed to hook fn.
        lpfnHook As Long           '  ptr. to hook function
        lpTemplateName As String   '  custom template name
        hInstance As Long          '  instance handle of.EXE that
                                   '    contains cust. dlg. template
        lpszStyle As String        '  return the style field here
                                   '  must be LF_FACESIZE or bigger
        nFontType As Integer       '  same value reported to the EnumFonts
                                   '    call back with the extra FONTTYPE_
                                   '    bits added
        MISSING_ALIGNMENT As Integer
        nSizeMin As Long           '  minimum pt size allowed &
        nSizeMax As Long           '  max pt size allowed if
                                   '    CF_LIMITSIZE is used
End Type
#Else
Type ChooseFont
    lStructSize As Long
    hwndOwner As Integer
    hdc As Integer
    lpLogFont As Long
    iPointSize As Integer
    flags As Long
    rgbColors As Long
    lCustData As Long
    lpfnHook As Long 'Integer
    lpTemplateName As Long
    hInstance  As Integer
    lpszStyle As Long
    nFontType As Integer
    nSizeMin As Integer
    nSizeMax As Integer
End Type
#End If

#If Win32 Then
Declare Function ChooseFont Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As ChooseFont) As Long
Declare Function VarPtr Lib "VB40032" (lpVoid As Any) As Long 'Secret VB Runtime function
#Else
Declare Function ChooseFont Lib "COMMDLG.DLL" (pChoosefont As ChooseFont) As Integer
#End If

Public Const CF_ANSIONLY = &H400&
Public Const CF_APPLY = &H200&
Public Const CF_EFFECTS = &H100&
Public Const CF_ENABLEHOOK = &H8&
Public Const CF_ENABLETEMPLATE = &H10&
Public Const CF_ENABLETEMPLATEHANDLE = &H20&
Public Const CF_FIXEDPITCHONLY = &H4000&
Public Const CF_FORCEFONTEXIST = &H10000
Public Const CF_INITTOLOGFONTSTRUCT = &H40&
Public Const CF_LIMITSIZE = &H2000&
Public Const CF_NOFACESEL = &H80000
Public Const CF_NOSCRIPTSEL = &H800000
Public Const CF_NOSIMULATIONS = &H1000&
Public Const CF_NOSIZESEL = &H200000
Public Const CF_NOSTYLESEL = &H100000
Public Const CF_NOVECTORFONTS = &H800&
Public Const CF_NOVERTFONTS = &H1000000
Public Const CF_OWNERDISPLAY = &H80
Public Const CF_PRINTERFONTS = &H2
Public Const CF_SCALABLEONLY = &H20000
Public Const CF_SCREENFONTS = &H1
Public Const CF_SCRIPTSONLY = CF_ANSIONLY
Public Const CF_SELECTSCRIPT = &H400000
Public Const CF_SHOWHELP = &H4&
Public Const CF_TTONLY = &H40000
Public Const CF_USESTYLE = &H80&
Public Const CF_WYSIWYG = &H8000
Public Const CF_BOTH = (CF_SCREENFONTS Or CF_PRINTERFONTS)
Public Const CF_NOOEMFONTS = CF_NOVECTORFONTS

Global Const SIMULATED_FONTTYPE = &H8000
Global Const PRINTER_FONTTYPE = &H4000
Global Const SCREEN_FONTTYPE = &H2000
Global Const BOLD_FONTTYPE = &H100
Global Const ITALIC_FONTTYPE = &H200
Global Const REGULAR_FONTTYPE = &H400

Global Const WM_CHOOSEFONT_GETLOGFONT = (&H400 + 1) 'WM_USER + 1

Global Const LBSELCHSTRING = "commdlg_LBSelChangedNotify"
Global Const SHAREVISTRING = "commdlg_ShareViolation"
Global Const FILEOKSTRING = "commdlg_FileNameOK"
Global Const COLOROKSTRING = "commdlg_ColorOK"
Global Const SETRGBSTRING = "commdlg_SetRGBColor"
Global Const FINDMSGSTRING = "commdlg_FindReplace"
Global Const HELPMSGSTRING = "commdlg_help"

Global Const CD_LBSELNOITEMS = -1
Global Const CD_LBSELCHANGE = 0
Global Const CD_LBSELSUB = 1
Global Const CD_LBSELADD = 2


'Printer related structures and function declarations ********************

#If Win32 Then
Type PRINTDLG
        lStructSize As Long
        hwndOwner As Long
        hDevMode As Long
        hDevNames As Long
        hdc As Long
        flags As Long
        nFromPage As Integer
        nToPage As Integer
        nMinPage As Integer
        nMaxPage As Integer
        nCopies As Integer
        hInstance As Long
        lCustData As Long
        lpfnPrintHook As Long
        lpfnSetupHook As Long
        lpPrintTemplateName As String
        lpSetupTemplateName As String
        hPrintTemplate As Long
        hSetupTemplate As Long
End Type
#Else
Type PRINTDLG
    lStructSize As Long
    hwndOwner As Integer
    hDevMode As Integer
    hDevNames As Integer
    hdc As Integer
    flags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Integer
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As Long
    lpSetupTemplateName As Long
    hPrintTemplate As Integer
    hSetupTemplate As Integer
End Type
#End If

#If Win32 Then
Declare Function PRINTDLG Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PRINTDLG) As Long
#Else
Declare Function PRINTDLG Lib "COMMDLG.DLL" Alias "PrintDlg" (pPrintdlg As PRINTDLG) As Integer
#End If

Global Const PD_ALLPAGES = &H0
Global Const PD_SELECTION = &H1
Global Const PD_PAGENUMS = &H2
Global Const PD_NOSELECTION = &H4
Global Const PD_NOPAGENUMS = &H8
Global Const PD_COLLATE = &H10
Global Const PD_PRINTTOFILE = &H20
Global Const PD_PRINTSETUP = &H40
Global Const PD_NOWARNING = &H80
Global Const PD_RETURNDC = &H100
Global Const PD_RETURNIC = &H200
Global Const PD_RETURNDEFAULT = &H400
Global Const PD_SHOWHELP = &H800
Global Const PD_ENABLEPRINTHOOK = &H1000
Global Const PD_ENABLESETUPHOOK = &H2000
Global Const PD_ENABLEPRINTTEMPLATE = &H4000
Global Const PD_ENABLESETUPTEMPLATE = &H8000
Global Const PD_ENABLEPRINTTEMPLATEHANDLE = &H10000
Global Const PD_ENABLESETUPTEMPLATEHANDLE = &H20000
Global Const PD_USEDEVMODECOPIES = &H40000
Global Const PD_DISABLEPRINTTOFILE = &H80000
Global Const PD_HIDEPRINTTOFILE = &H100000

Type DEVNAMES                 'Same in Win16 and Win32
    wDriverOffset As Integer
    wDeviceOffset As Integer
    wOutputOffset As Integer
    wDefault As Integer
End Type

Global Const DN_DEFAULTPRN = &H1

'retrieves error value

#If Win32 Then
Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long
#Else
Declare Function CommDlgExtendedError Lib "COMMDLG.DLL" () As Long
#End If

'************************* end of Common Dialogs Declares ************

' GLOBAL MEMORY Stuff

#If Win32 Then
Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
#Else
Declare Function GlobalAlloc Lib "Kernel" (ByVal wFlags As Integer, ByVal dwBytes As Long) As Integer
Declare Function GlobalFree Lib "Kernel" (ByVal hMem As Integer) As Integer
Declare Function GlobalLock Lib "Kernel" (ByVal hMem As Integer) As Long
Declare Function GlobalUnlock Lib "Kernel" (ByVal hMem As Integer) As Integer
#End If


Global Const GMEM_MOVEABLE = &H2
Global Const GMEM_ZEROINIT = &H40
Global Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)

#If Win32 Then
Declare Sub MemoryCopy Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal dwBytes As Long)
#Else
Declare Sub MemoryCopy Lib "Kernel" Alias "hmemcpy" (lpDest As Any, lpSource As Any, ByVal dwBytes As Long)
#End If

'PRINTER stuff

#If Win32 Then
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
#Else
Declare Function DeleteDC Lib "GDI" (ByVal hdc As Integer) As Integer
#End If

#If Win32 Then
Type DEVMODE
        dmDeviceName As String * CCHDEVICENAME
        dmSpecVersion As Integer
        dmDriverVersion As Integer
        dmSize As Integer
        dmDriverExtra As Integer
        dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
        dmColor As Integer
        dmDuplex As Integer
        dmYResolution As Integer
        dmTTOption As Integer
        dmCollate As Integer
        dmFormName As String * CCHFORMNAME
        dmUnusedPadding As Integer
        dmBitsPerPel As Integer
        dmPelsWidth As Long
        dmPelsHeight As Long
        dmDisplayFlags As Long
        dmDisplayFrequency As Long
End Type
#Else
Type DEVMODE
          dmDeviceName As String * 32
          dmSpecVersion As Integer
          dmDriverVersion As Integer
          dmSize As Integer
          dmDriverExtra As Integer
          dmFields As Long
          dmOrientation As Integer
          dmPaperSize As Integer
          dmPaperLength As Integer
          dmPaperWidth As Integer
          dmScale As Integer
          dmCopies As Integer
          dmDefaultSource As Integer
          dmPrintQuality As Integer
          dmColor As Integer
          dmDuplex As Integer
          dmYResolution As Integer
          dmTTOption As Integer
End Type
#End If
