VERSION 4.00
Begin VB.Form Form1 
   Appearance      =   0  'Flat
   BackColor       =   &H00C0C0C0&
   Caption         =   "Common Dialogs Made in VB"
   ClientHeight    =   3480
   ClientLeft      =   1275
   ClientTop       =   1755
   ClientWidth     =   6840
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   4170
   Icon            =   "DIALOGS.frx":0000
   Left            =   1215
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   3480
   ScaleWidth      =   6840
   Top             =   1125
   Width           =   6960
   Begin VB.Menu mnuDemo 
      Caption         =   "&Demo"
      Begin VB.Menu mnuFOpen 
         Caption         =   "File &Open"
      End
      Begin VB.Menu mnuFSave 
         Caption         =   "File &Save"
      End
      Begin VB.Menu mnuFonts 
         Caption         =   "&Fonts"
      End
      Begin VB.Menu mnuPrinter 
         Caption         =   "&Printer"
         Begin VB.Menu mnuPSetup 
            Caption         =   "Printer Setup"
         End
         Begin VB.Menu mnuPDoc 
            Caption         =   "Print Doc Setup"
         End
      End
      Begin VB.Menu mnuColors 
         Caption         =   "&Colors"
      End
      Begin VB.Menu mnuSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Rem Demo for accessing Win 3.1 Common Dialogs
Rem Author: Costas Kitsos, CIS 73667,1755
Rem Revision: 1.00.00, July 4 1992

DefInt A-Z

Private Sub Form_Load()
    Form1.Height = (Screen.Height * 3) \ 4
    Form1.Width = (Screen.Width * 3) \ 4
    Move (Screen.Width - Form1.Width) \ 2, (Screen.Height - Form1.Height) \ 2
End Sub

Private Sub mnuColors_Click()
    
    Cls

    Dim C As CHOOSECOLOR
    Dim Address As Long
    #If Win32 Then
        Dim Memhandle As Long, wSize As Long
    #End If

    ReDim ClrArray(15) As Long    ' Holds Custom Colors

    wSize = Len(ClrArray(0)) * 16 ' Size of Memory Block

    'A global block is allocated to hold a copy of the
    'custom colors
    Memhandle = GlobalAlloc(GHND, wSize)

    If Memhandle = 0 Then Exit Sub

    Address = GlobalLock(Memhandle)

    ' Fill Custom Colors with White

    For i& = 0 To UBound(ClrArray)
        ClrArray(i&) = &HFFFFFF
    Next

    'copy custom colors to the global block
    Call MemoryCopy(ByVal Address, ClrArray(0), wSize)

    'get ready to call ChooseColor
    C.lStructSize = Len(C)
    C.hwndOwner = hWnd
    C.lpCustColors = Address
    C.rgbResult = Form1.BackColor
    C.flags = CC_RGBINIT Or CC_FULLOPEN

    Result = CHOOSECOLOR(C)

    ' copy the new custom colors locally
    Call MemoryCopy(ClrArray(0), ByVal Address, wSize)
    
    Ok = GlobalUnlock(Memhandle)    'Free The Memory
    Ok = GlobalFree(Memhandle)

    If Result = 0 Then Exit Sub

    'select the new color for the background
    'comment this out if it's distracting
    Form1.BackColor = C.rgbResult

    ' print the new custom colors

    For i& = 0 To UBound(ClrArray)
        Print "Custom Color"; Str$(i&); ":", Hex$(ClrArray(i&))
    Next

End Sub

Private Sub mnuExit_Click()
    End
End Sub

Private Sub mnuFonts_Click()
    
    Cls

    ' Save the defaults
    OldFont$ = Form1.FontName
    OldFontSize = Form1.FontSize
    OldFontWeight = Form1.FontBold
    OldFontItalic = Form1.FontItalic
    OldFontStrikethru = Form1.FontStrikethru
    OldFontUnderline = Form1.FontUnderline
    OldForeColor& = Form1.ForeColor

    Dim A As ChooseFont
    Dim F As LOGFONT
    Dim Address As Long
    Dim Memhandle As Long
    Dim FaceNameString As String
    
    #If Win32 Then
        Dim Result As Long
    #End If

    ' We need to use GlobalAlloc to provide lpLogFont which is a
    ' pointer to a LogFont structure (for Win16)
    
    #If Win16 Then
        Memhandle = GlobalAlloc(GHND, Len(F))
        If Memhandle = 0 Then Exit Sub
        Address = GlobalLock(Memhandle)
    #End If
        
    
    #If Win32 Then
        A.lpLogFont = VarPtr(F) ' Get pointer to structure for Win32
    #Else
        A.lpLogFont = Address
    #End If
    
    A.hdc = Form1.hdc
    A.lStructSize = Len(A)
    A.hwndOwner = Form1.hWnd
    A.flags = CF_SCREENFONTS Or CF_EFFECTS
    A.nFontType = SCREEN_FONTTYPE
    
    Result = ChooseFont(A)
    If Result = 0 Then Exit Sub
    
    #If Win16 Then
    ' make a local copy of the LogFont structure
        If Result <> 0 Then Call MemoryCopy(F, ByVal Address, Len(F))
        Ok = GlobalUnlock(Memhandle)    'Free The Memory
        Ok = GlobalFree(Memhandle)
        FaceNameString = F.lfFaceName 'Convert to string for portability below - PMC
    #Else
        FaceNameString = StrConv(F.lfFaceName, vbUnicode) 'Convert to string from byte array
    #End If


    'calculate the font size in points
    FntSize = Abs(F.lfHeight * (72 / GetDeviceCaps(hdc, LOGPIXELSY)))
    Print "Font: ", Left$(FaceNameString, InStr(FaceNameString, Chr$(0)) - 1)
    Print "Height:", FntSize
    Print "Weight: ", F.lfWeight
    Print "Italic: ", Asc(F.lfItalic)

    'select the new font
    Form1.FontName = Left$(FaceNameString, InStr(FaceNameString, Chr$(0)) - 1)
    Form1.FontSize = FntSize
    
    #If Win16 Then 'this is a hack because Win16 doesn't have bytes
        Form1.FontItalic = Asc(F.lfItalic)
        Form1.FontStrikethru = Asc(F.lfStrikeOut)
        Form1.FontUnderline = Asc(F.lfUnderline)
    #Else
        Form1.FontItalic = F.lfItalic
        Form1.FontStrikethru = F.lfStrikeOut
        Form1.FontUnderline = F.lfUnderline
    #End If
        
    Form1.ForeColor = A.rgbColors
    If F.lfWeight < 500 Then Form1.FontBold = 0 Else Form1.FontBold = -1

    Print Form1.FontName; FntSize 'print something

    'restore the defaults
    Form1.FontName = OldFont$
    Form1.FontSize = OldFontSize
    Form1.FontBold = OldFontWeight
    Form1.FontItalic = OldFontItalic
    Form1.FontStrikethru = OldFontStrikethru
    Form1.FontUnderline = OldFontUnderline
    Form1.ForeColor = OldForeColor&

End Sub

Private Sub mnuFOpen_Click()
    
    Cls

    Dim O As OPENFILENAME
    Dim wSize As Long
    #If Win32 Then
        Dim Memhandle As Long, hWnd As Long
    #Else
        Dim Memhandle As Integer, hWnd As Integer, Address As Long
    #End If
    

    szFile$ = String$(128, 0)
    szFilter$ = "VB Files" + Chr$(0) + "*.frm;*.bas;*.mak" + Chr$(0) + "Text Files" + Chr$(0) + "*.txt;*.doc" + Chr$(0) + Chr$(0)

    #If Win16 Then
    'First Copy the strings to the Global Memory Block
    'use a sub-allocation scheme to avoid overloading the LDT
        wSize = Len(szFile$) + Len(szFilter$)
        Memhandle = GlobalAlloc(GHND, wSize)
        If Memhandle = 0 Then Exit Sub
        Address = GlobalLock(Memhandle)
        Call MemoryCopy(ByVal Address, ByVal (szFile$ + szFilter$), wSize)
    #End If
  
    O.lStructSize = Len(O)
    O.hwndOwner = hWnd
    O.flags = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
    O.nFilterIndex = 1
    O.nMaxFile = Len(szFile$)
    
    #If Win32 Then
        O.lpstrFile = szFile$
        O.lpstrFilter = szFilter$
    #Else
        O.lpstrFile = Address
        O.lpstrFilter = Address + Len(szFile$)
    #End If

    Result = GetOpenFileName(O)
    If Result = 0 Then Exit Sub

    #If Win16 Then
        If Result <> 0 Then Call MemoryCopy(ByVal szFile$, ByVal Address, Len(szFile$))
        Ok = GlobalUnlock(Memhandle)    'Free The Memory
        Ok = GlobalFree(Memhandle)
        File$ = Left$(szFile$, InStr(szFile$, Chr$(0)) - 1)
    #Else
        File$ = Left$(O.lpstrFile, InStr(O.lpstrFile, Chr$(0)) - 1)
    #End If
    
    Print "Common Dialogs File Open"
    Print
    Print "You selected: ", File$
    Print "Path:", Left$(File$, O.nFileOffset)
    Print "Filename:", Right$(File$, Len(File$) - O.nFileOffset)
    Print "Extension:", Right$(File$, Len(File$) - O.nFileExtension)

End Sub

Private Sub mnuFSave_Click()
    
    Cls

    ' This is similar to GetOpenFileName
    Dim S As OPENFILENAME
    #If Win32 Then
        Dim Memhandle As Long, wSize As Long
    #Else
        Dim Address As Long, hWnd As Integer, Memhandle As Integer
    #End If

    'First Copy the strings to the Global Memory Block
    'use a sub-allocation scheme to avoid wearing down the LDT

    NoTitle$ = "untitled.frm"
    szFile$ = NoTitle$ + String$(128 - Len(NoTitle$), 0)
    szFilter$ = "VB Files" + Chr$(0) + "*.frm;*.bas;*.mak" + Chr$(0) + "Text Files" + Chr$(0) + "*.txt;*.doc" + Chr$(0) + Chr$(0)
    
    #If Win16 Then
        wSize = Len(szFile$) + Len(szFilter$)
        Memhandle = GlobalAlloc(GHND, wSize)
        If Memhandle = 0 Then Exit Sub
        Address = GlobalLock(Memhandle)
        Call MemoryCopy(ByVal Address, ByVal (szFile$ + szFilter$), wSize)
    #End If
    S.lStructSize = Len(S)
    S.hwndOwner = hWnd
    S.flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
    S.nFilterIndex = 1
    S.nMaxFile = Len(szFile$)
    #If Win32 Then
        S.lpstrFile = szFile$
        S.lpstrFilter = szFilter$
    #Else
        S.lpstrFile = Address
        S.lpstrFilter = Address + Len(szFile$)
    #End If

    Result = GetSaveFileName(S)
    If Result = 0 Then Exit Sub

    #If Win16 Then
        If Result <> 0 Then Call MemoryCopy(ByVal szFile$, ByVal Address, Len(szFile$))
        Ok = GlobalUnlock(Memhandle)    'Free The Memory
        Ok = GlobalFree(Memhandle)
        File$ = Left$(szFile$, InStr(szFile$, Chr$(0)) - 1)
    #Else
        File$ = Left$(S.lpstrFile, InStr(S.lpstrFile, Chr$(0)) - 1)
    #End If
    
    Print "Common Dialogs File Save"
    Print
    Print "You selected: ", File$
    Print "Path:", Left$(File$, S.nFileOffset)
    Print "Filename:", Right$(File$, Len(File$) - S.nFileOffset)
    Print "Extension:", Right$(File$, Len(File$) - S.nFileExtension)


End Sub

Private Sub mnuPDoc_Click()
    
    Cls

    'This is similar to Printer Setup
    Dim Address As Long
    Dim P As PRINTDLG
    Dim D As DEVMODE
    #If Win32 Then
        Dim Memhandle As Long, wSize As Long
    #End If
    
    P.lStructSize = Len(P)
    P.hwndOwner = hWnd
    P.flags = PD_RETURNIC
    P.nFromPage = 1
    P.nToPage = 12
    P.nMinPage = 1
    P.nMaxPage = 12
    P.nCopies = 1
    Result = PRINTDLG(P)
    
    If Result = 0 Then Exit Sub
    
    If P.hdc <> 0 Then Ok = DeleteDC(P.hdc)
    If P.hDevNames <> 0 Then Ok = GlobalFree(P.hDevNames)
    
    Address = GlobalLock(P.hDevMode)
    Call MemoryCopy(D, ByVal Address, Len(D))
    Ok = GlobalUnlock(P.hDevMode)
    Ok = GlobalFree(P.hDevMode)
    
    Print "Printer:", Left$(D.dmDeviceName, InStr(D.dmDeviceName, Chr$(0)) - 1)
    Print "From Page:", P.nFromPage
    Print "To Page:", P.nToPage
    Print "Copies:", P.nCopies

End Sub

Private Sub mnuPSetup_Click()
    
    Cls

    Dim Address As Long
    Dim P As PRINTDLG
    Dim D As DEVMODE
    #If Win32 Then
        Dim Memhandle As Long, wSize As Long
    #End If

    P.lStructSize = Len(P)
    P.hwndOwner = hWnd
    P.flags = PD_PRINTSETUP
    Result = PRINTDLG(P)
    
    If Result = 0 Then Exit Sub
    
    'PrintDlg() returns an hDC, a global handle to hDevNames
    'and another to hDevMode.  Delete the ones we don't need

    If P.hdc <> 0 Then Ok = DeleteDC(P.hdc)
    If P.hDevNames <> 0 Then Ok = GlobalFree(P.hDevNames)

    'Make a local copy of the global block (hDevMode)
    Address = GlobalLock(P.hDevMode)
    Call MemoryCopy(D, ByVal Address, Len(D))

    Ok = GlobalUnlock(P.hDevMode) 'free the memory
    Ok = GlobalFree(P.hDevMode)
    
    Print "Printer:", Left$(D.dmDeviceName, InStr(D.dmDeviceName, Chr$(0)) - 1)
    Print "Orientation:", D.dmOrientation

End Sub

