VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Registry Additions for REGSVR32.EXE"
   ClientHeight    =   5715
   ClientLeft      =   1800
   ClientTop       =   1560
   ClientWidth     =   7260
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   5715
   ScaleWidth      =   7260
   Begin VB.CommandButton cmdProcede 
      Caption         =   "&Procede"
      Height          =   420
      Left            =   2610
      TabIndex        =   1
      Top             =   5205
      Width           =   1560
   End
   Begin VB.TextBox txtStatus 
      Height          =   5025
      Left            =   60
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   60
      Width           =   6870
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim msKeyOCX As String
Dim msKeyOCXFile As String
Dim msKeyDLL As String
Dim msKeyDLLFile As String

'When the above variables are used in a comment, it's usually referring
'to the value assigned to that variable.

Const ABORTMSG = vbCrLf & "Procedure Aborted!!"


Private Function CreateTopKeys() As Boolean

'This function creates the 4 top-level keys for the values we previously
'obtained for msKeyDLL, mskeyDLLFile, msKeyOCX, and msKeyOCXFile IF
'they do not already exist.  If all 4 keys were successfully created (or
'already existed), True is returned.  If ANY key is not created, False is
'returned.

Dim sKeyName As String
Dim sSetting As String
Dim sValue As String
Dim bSuccess As Boolean
Dim sMsg As String

sMsg = txtStatus

CreateTopKeys = False 'not really neccessary, but I believe in being clear.  :)

If Len(msKeyDLL) = 0 Then
    msKeyDLL = "HKEY_CLASSES_ROOT\.dll"
    bSuccess = CreateRegKey(msKeyDLL)
    If bSuccess Then
        sMsg = sMsg & Chr$(34) & msKeyDLL & Chr$(34) & " was successfully created." & vbCrLf
    Else
        sMsg = sMsg & Chr$(34) & msKeyDLL & Chr$(34) & " was not successfully created." & vbCrLf
        Exit Function
    End If
End If

'One down, three to go
If Len(msKeyDLLFile) = 0 Then
    msKeyDLLFile = "HKEY_CLASSES_ROOT\dllfile"
    bSuccess = CreateRegKey(msKeyDLLFile)
    If bSuccess Then
        sMsg = sMsg & Chr$(34) & msKeyDLLFile & Chr$(34) & " was successfully created." & vbCrLf
    Else
        sMsg = sMsg & Chr$(34) & msKeyDLLFile & Chr$(34) & " was not successfully created." & vbCrLf
        Exit Function
    End If
End If

If Len(msKeyOCX) = 0 Then
    msKeyOCX = "HKEY_CLASSES_ROOT\.ocx"
    bSuccess = CreateRegKey(msKeyOCX)
    If bSuccess Then
        sMsg = sMsg & Chr$(34) & msKeyOCX & Chr$(34) & " was successfully created." & vbCrLf
    Else
        sMsg = sMsg & Chr$(34) & msKeyOCX & Chr$(34) & " was not successfully created." & vbCrLf
        Exit Function
    End If
    'We also need to to write a default value for msKeyOCX so it "points"
    'to msKeyOCXFile
    sKeyName = msKeyOCX
    sSetting = ""
    sValue = "ocxfile"
    bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
    If Not bSuccess Then
        Exit Function
    Else
        txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & sKeyName & "." & vbCrLf
    End If
End If

If Len(msKeyOCXFile) = 0 Then
    msKeyOCXFile = "HKEY_CLASSES_ROOT\ocxfile"
    bSuccess = CreateRegKey(msKeyOCXFile)
    If bSuccess Then
        sMsg = sMsg & Chr$(34) & msKeyOCXFile & Chr$(34) & " was successfully created." & vbCrLf
    Else
        sMsg = sMsg & Chr$(34) & msKeyOCXFile & Chr$(34) & " was not successfully created." & vbCrLf
        Exit Function
    End If
End If

CreateTopKeys = True
txtStatus = sMsg

End Function

Private Sub cmdProcede_Click()

Dim sKeyName As String
Dim sSetting As String
Dim sValue As String
Dim bSuccess As Boolean
Dim sWinDir As String
Dim sSysDir As String

If Not CreateTopKeys Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
End If

'Keys are created so it's OK to continue.
'Create "shell\register\command" and "shell\unregister\command" keys under msKeyDLLFile
sKeyName = msKeyDLLFile & "\shell\register\command"
bSuccess = CreateRegKey(sKeyName)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr$(34) & sKeyName & Chr$(34) & " was successfully created." & vbCrLf
End If

sKeyName = msKeyDLLFile & "\shell\unregister\command"
bSuccess = CreateRegKey(sKeyName)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr$(34) & sKeyName & Chr$(34) & " was successfully created." & vbCrLf
End If

'Now create these keys under msKeyOCXFile
sKeyName = msKeyOCXFile & "\shell\register\command"
bSuccess = CreateRegKey(sKeyName)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr$(34) & sKeyName & Chr$(34) & " was successfully created." & vbCrLf
End If

sKeyName = msKeyOCXFile & "\shell\unregister\command"
bSuccess = CreateRegKey(sKeyName)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr$(34) & sKeyName & Chr$(34) & " was successfully created." & vbCrLf
End If

txtStatus = txtStatus & vbCrLf

'Write default values for both sets of the "register" and "unregister" keys.
'This is the text that appears in the context sensitive menu.
sKeyName = msKeyDLLFile & "\shell\register"
sSetting = ""
sValue = "Register"
bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & Chr$(34) & sKeyName & Chr$(34) & "." & vbCrLf
End If

sKeyName = msKeyDLLFile & "\shell\unregister"
sSetting = ""
sValue = "Unregister"
bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & Chr$(34) & sKeyName & Chr$(34) & "." & vbCrLf
End If

sKeyName = msKeyOCXFile & "\shell\register"
sSetting = ""
sValue = "Register"
bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & Chr$(34) & sKeyName & Chr$(34) & "." & vbCrLf
End If

sKeyName = msKeyOCXFile & "\shell\unregister"
sSetting = ""
sValue = "Unregister"
bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & Chr$(34) & sKeyName & Chr$(34) & "." & vbCrLf
End If

txtStatus = txtStatus & vbCrLf

'We're almost done.  All that's left is to write the command lines for the
'4 "command" keys.

sKeyName = msKeyDLLFile & "\shell\register\command"
sSetting = ""
sValue = Chr$(34) & "regsvr32.exe" & Chr$(34) & " " & Chr$(34) & "%1" & Chr$(34)
'Chr$(34) is a quotation mark.  I find this method easier to read and
'understand than using double quotation marks to include the mark as part
'of the string.
bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & Chr$(34) & sKeyName & Chr$(34) & "." & vbCrLf
End If

sKeyName = msKeyDLLFile & "\shell\unregister\command"
sSetting = ""
sValue = Chr$(34) & "regsvr32.exe" & Chr$(34) & " /u " & Chr$(34) & "%1" & Chr$(34)
bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & Chr$(34) & sKeyName & Chr$(34) & "." & vbCrLf
End If

sKeyName = msKeyOCXFile & "\shell\register\command"
sSetting = ""
sValue = Chr$(34) & "regsvr32.exe" & Chr$(34) & " " & Chr$(34) & "%1" & Chr$(34)
bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & Chr$(34) & sKeyName & Chr$(34) & "." & vbCrLf
End If

sKeyName = msKeyOCXFile & "\shell\unregister\command"
sSetting = ""
sValue = Chr$(34) & "regsvr32.exe" & Chr$(34) & " /u " & Chr$(34) & "%1" & Chr$(34)
bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
If Not bSuccess Then
    txtStatus = txtStatus & ABORTMSG
    Exit Sub
Else
    txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & Chr$(34) & sKeyName & Chr$(34) & "." & vbCrLf
End If

'We'll do one more little thing.  If msKeyOCXFile does not have a default
'value, we'll write one.  This value is what appears underneath the Type column
'in Explorer.
sKeyName = msKeyOCXFile
sSetting = ""
sValue = ""
Call GetRegStringValue(sKeyName, sSetting, sValue)
If Len(sValue) = 0 Then
    sValue = "ActiveX Custom Control"
    bSuccess = WriteRegStringValue(sKeyName, sSetting, sValue)
    If bSuccess Then
        txtStatus = txtStatus & Chr(34) & sValue & Chr$(34) & " was successfully written to " & Chr$(34) & sKeyName & Chr$(34) & "." & vbCrLf
    End If
End If

txtStatus = txtStatus & vbCrLf

'Now, as a final message, let's make sure that REGSVR32.EXE exists in either
'the Windows or System directory because these command lines assume that
'REGSVR32.EXE is in a directory where it can be found without a specified path.
sWinDir = GetWinDir()
If Not FileOrDirExists("regsvr32.exe", sWinDir) Then
    'Not there, so let's check the System directory
    sSysDir = GetWinSysDir()
    If Not FileOrDirExists("regsvr32.exe", sSysDir) Then
        txtStatus = txtStatus & "Regsvr32.exe was not found in your Windows or System directory.  "
        txtStatus = txtStatus & "Be sure to copy this file to that location so it can be found."
    End If
End If

cmdProcede.Enabled = False

End Sub

Private Sub Form_Load()

Dim sKeyName As String
Dim sSetting As String
Dim sValue As String
Dim bSuccess As Boolean
Dim sMsg As String

'First thing to do is verify there are Registry keys
'for ".dll" and "dllfile".  These SHOULD exist already.

sKeyName = "HKEY_CLASSES_ROOT\.dll"
sSetting = ""  'Leave this an empty string to get "default" value
bSuccess = GetRegStringValue(sKeyName, sSetting, sValue)
If bSuccess Then
    'The key exists but we need to make sure there is a default value.
    'Lack of a default value indicates a problem that this program is not
    'designed to handle.
    If Len(sValue) = 0 Then
        sMsg = sMsg & vbCrLf
        sMsg = sMsg & Chr$(34) & sKeyName & Chr$(34) & " exists but it has no default value which "
        sMsg = sMsg & "refers to another key under HKEY_CLASSES_ROOT.  This does "
        sMsg = sMsg & "not necessarily mean your Registry is corrupt, but it "
        sMsg = sMsg & "does not follow standard practices for registered file "
        sMsg = sMsg & "types.  This program is not designed for handling such "
        sMsg = sMsg & "situations.  Programs such as Norton Utilities or Microsoft's "
        sMsg = sMsg & "RegClean might fix this problem." & vbCrLf
        txtStatus = sMsg
        cmdProcede.Enabled = False
        Exit Sub
    End If
    msKeyDLL = sKeyName
    sMsg = Chr$(34) & sKeyName & Chr$(34) & " exists and has the default value " & Chr(34) & sValue & Chr$(34) & "." & vbCrLf
    sKeyName = "HKEY_CLASSES_ROOT\" & sValue
    sSetting = ""
    'Now let's make sure that the key "pointed" to by msKeyDLL exists
    bSuccess = GetRegStringValue(sKeyName, sSetting, sValue)
    If bSuccess Then
        msKeyDLLFile = sKeyName
        sMsg = sMsg & Chr$(34) & sKeyName & Chr$(34) & " exists and has the default value "
        If Len(sValue) Then
            sMsg = sMsg & Chr(34) & sValue & Chr$(34) & "." & vbCrLf
        Else
            sMsg = sMsg & Chr$(34) & Chr$(34) & "." & vbCrLf
        End If
    Else
        sMsg = sMsg & Chr$(34) & sKeyName & Chr$(34) & " does not exist." & vbCrLf
    End If
Else
    sMsg = sMsg & Chr$(34) & sKeyName & Chr$(34) & " does not exist." & vbCrLf
End If

'Do the same thing for the ".ocx" key.  It's more likely this one
'will not exist.
sKeyName = "HKEY_CLASSES_ROOT\.ocx"
sSetting = ""
sValue = ""
bSuccess = GetRegStringValue(sKeyName, sSetting, sValue)

If bSuccess Then
    'The key exists but we need to make sure there is a default value.
    'Lack of a default value indicates a problem that this program is not
    'designed to handle.
    If Len(sValue) = 0 Then
        sMsg = sMsg & vbCrLf
        sMsg = sMsg & Chr$(34) & sKeyName & Chr$(34) & " exists but it has no default value which "
        sMsg = sMsg & "refers to another key under HKEY_CLASSES_ROOT.  This does "
        sMsg = sMsg & "not necessarily mean your Registry is corrupt, but it "
        sMsg = sMsg & "does not follow standard practices for registered file "
        sMsg = sMsg & "types.  This program is not designed for handling such "
        sMsg = sMsg & "situations.  Programs such as Norton Utilities or Microsoft's "
        sMsg = sMsg & "RegClean might fix this problem." & vbCrLf
        txtStatus = sMsg
        cmdProcede.Enabled = False
        Exit Sub
    End If
    msKeyOCX = sKeyName
    sMsg = sMsg & Chr$(34) & sKeyName & Chr$(34) & " exists and has the default value " & Chr(34) & sValue & Chr$(34) & "." & vbCrLf
    sKeyName = "HKEY_CLASSES_ROOT\" & sValue
    sSetting = ""
    bSuccess = GetRegStringValue(sKeyName, sSetting, sValue)
    If bSuccess Then
        msKeyOCXFile = sKeyName
        sMsg = sMsg & Chr$(34) & sKeyName & Chr$(34) & " exists and has the default value "
        If Len(sValue) Then
            sMsg = sMsg & Chr(34) & sValue & Chr$(34) & "." & vbCrLf
        Else
            sMsg = sMsg & Chr$(34) & Chr$(34) & "." & vbCrLf
        End If
    End If
Else
    sMsg = sMsg & Chr$(34) & sKeyName & Chr$(34) & " does not exist." & vbCrLf
End If

'Now that we know which keys exist and which don't, we can
'provide information about what keys need to be created.
sMsg = sMsg & vbCrLf  'blank line

If Len(msKeyDLL) = 0 Then
    sMsg = sMsg & """HKEY_CLASSES_ROOT\.dll"" will be created." & vbCrLf
End If

If Len(msKeyDLLFile) = 0 Then
    sMsg = sMsg & """HKEY_CLASSES_ROOT\dllfile"" will be created." & vbCrLf
End If

If Len(msKeyOCX) = 0 Then
    sMsg = sMsg & """HKEY_CLASSES_ROOT\.ocx"" will be created." & vbCrLf
End If

If Len(msKeyOCXFile) = 0 Then
    sMsg = sMsg & """HKEY_CLASSES_ROOT\ocxfile"" will be created." & vbCrLf
End If


txtStatus = sMsg & vbCrLf

End Sub


Private Sub Form_Resize()

Dim CmdButtonLeft As Integer

On Error Resume Next

'Keep the command button centered horizontally
CmdButtonLeft = (frmMain.ScaleWidth - cmdProcede.Width) \ 2
cmdProcede.Move CmdButtonLeft, frmMain.ScaleHeight - cmdProcede.Height - 100

'resize the textbox
txtStatus.Move 0, 50, frmMain.ScaleWidth, frmMain.ScaleHeight - cmdProcede.Height - 300

End Sub


