VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   5715
   ClientLeft      =   1665
   ClientTop       =   1545
   ClientWidth     =   6585
   LinkTopic       =   "Form1"
   ScaleHeight     =   5715
   ScaleWidth      =   6585
   Begin VB.CommandButton Command1 
      Caption         =   "Get Drive Info"
      Height          =   495
      Left            =   2625
      TabIndex        =   1
      Top             =   4935
      Width           =   1215
   End
   Begin VB.TextBox Text1 
      Height          =   4665
      Left            =   60
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "frmMain.frx":0000
      Top             =   60
      Width           =   6480
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type OsVersionInfo
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OsVersionInfo) As Long
'  dwPlatformId defines:
Private Const VER_PLATFORM_WIN32s = 0
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32_NT = 2

'  Drive Info API's

'Need to change this so it works with OSR2 and drives greater than 2 GB!!!!
Private Declare Function GetDiskFreeSpace Lib "kernel32" Alias "GetDiskFreeSpaceA" (ByVal lpRootPathName As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTotalNumberOfClusters As Long) As Long

'See the comments in GetDriveInfo for information about the use of the Currency data type
Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" _
   Alias "GetDiskFreeSpaceExA" (ByVal lpRootPathName As String, _
   lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, _
   lpTotalNumberOfFreeBytes As Currency) As Long
   
Private Declare Function GetLogicalDrives Lib "kernel32" () As Long
Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Private Declare Function WNetGetConnection Lib "mpr.dll" Alias "WNetGetConnectionA" (ByVal lpszLocalName As String, ByVal lpszRemoteName As String, cbRemoteName As Long) As Long
Private Const DRIVE_REMOVABLE = 2
Private Const DRIVE_FIXED = 3
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_CDROM = 5
Private Const DRIVE_RAMDISK = 6

Private Declare Function GetVolumeInformation Lib "kernel32" Alias _
"GetVolumeInformationA" (ByVal lpRootPathName As String, _
ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, _
lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, _
lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, _
ByVal nFileSystemNameSize As Long) As Long

Private Sub GetDriveInfo(ByVal nWinBuild As Integer)

'Obtains information about all configured drives.

'GetDiskFreeSpace will return incorrect information under OSR2
'and Win98 if a drive is larger than 2GB (which requires FAT32).

'However, versions of Win95 less than OSR2 do NOT support
'GetDiskFreeSpaceEx.  This is why the Windows build number
'is passed to this function.  If the build number is >= 1111,
'OSR2 or later (i.e. Win98) is installed.  Check this and call
'the appropriate function.

'Even if FAT32 is not installed on an OSR2 or Win98 system,
'GetDiskFreeSpaceEx always will return the correct information.
'For more information regarding GetDiskFreeSpaceEx, see the
'additional comments below

Dim sTemp As String
Dim lResult As Long
Dim nBytes As Long
Dim sBuffer As String
Dim nBuffer As Long

'Used by GetDiskFreeSpace
Dim lpSectorsPerCluster As Long
Dim lpBytesPerSector As Long
Dim lpNumberOfFreeClusters As Long
Dim lpTotalNumberOfClusters As Long

'Used by GetVolumeInformation
Dim lSerialNumber As Long
Dim lMaxCompLen As Long
Dim lFileSysFlags As Long

'*************************************************
'Used by GetDiskFreeSpaceEx
'Why are we using the currency data type?
'The SDK mentions in the Remarks section for GetDiskFreeSpaceEx:

'"Note that the values obtained by this function are of type ULARGE_INTEGER.
'Be careful not to truncate these values to 32 bits."

'A quick check in the Data Types Summary of the VB help file
'shows that a Long data type is 4 bytes (32 bits), so if we
'used a Long, we would do exactly what the SDK warned NOT to do.
'Checking the summary again, we find that the Currency data type
'is 8 bytes (64 bits) and is really just a scaled integer, allowing
'it to have 4 decimal places.  8 bytes is also exactly the size
'of the ULARGE_INTEGER.  So, we use the currency data type for
'the variables below and also for the parameter list in the declaration
'for GetDiskFreeSpaceEx and then just multiply by 10000 to "convert"
'the value to a Long integer.
Dim cBytesFreeToCaller As Currency
Dim cTotalBytes As Currency
Dim cTotalFreeBytes As Currency
'*************************************************

Dim lTotalBytes As Long
Dim lTotalFreeBytes As Long
Dim lBytesFreeToCaller As Long  'only if calling GetDiskFreeSpaceEx
Dim sDrives As String
Dim sRootDir As String
Dim lDriveType As Long

'Get all valid drives letters
sBuffer = Space$(255)
nBuffer = Len(sBuffer)
nBytes = GetLogicalDriveStrings(nBuffer, sBuffer)
sDrives = Left$(sBuffer, nBytes)
sTemp = "Disk Drives:" & vbCrLf

Do While Len(sDrives)
    'pull one off the front
    sRootDir = UCase$(Left$(sDrives, 3))
    sDrives = Mid$(sDrives, 5)
    lDriveType = GetDriveType(sRootDir)
    
    lBytesFreeToCaller = 0
    lTotalBytes = 0
    lTotalFreeBytes = 0
    cBytesFreeToCaller = 0
    cTotalBytes = 0
    cTotalFreeBytes = 0
    lpSectorsPerCluster = 0
    lpBytesPerSector = 0
    lpNumberOfFreeClusters = 0
    lpTotalNumberOfClusters = 0
    
    Select Case lDriveType
        Case DRIVE_REMOVABLE
            sTemp = sTemp & "     " & sRootDir & "     [removable]" & vbCrLf
        Case DRIVE_FIXED
            sTemp = sTemp & "     " & sRootDir & "     [fixed disk]" & vbCrLf
            If nWinBuild >= 1111 Then     'OSR2 or later
                lResult = GetDiskFreeSpaceEx(sRootDir, cBytesFreeToCaller, cTotalBytes, cTotalFreeBytes)
                'multiply the returned value by 10000 to adjust for the 4
                'decimal places that the currency data type returns.
                lTotalBytes = cTotalBytes * 10000
                lTotalFreeBytes = cTotalFreeBytes * 10000
                lBytesFreeToCaller = cBytesFreeToCaller * 10000
            Else
                lResult = GetDiskFreeSpace(sRootDir, lpSectorsPerCluster, lpBytesPerSector, lpNumberOfFreeClusters, lpTotalNumberOfClusters)
                'Calculate total bytes and free bytes using the info obtained from GetDiskFreeSpace
                lTotalBytes = lpSectorsPerCluster * lpBytesPerSector * lpTotalNumberOfClusters
                lTotalFreeBytes = lpSectorsPerCluster * lpBytesPerSector * lpNumberOfFreeClusters
            End If
                
            sTemp = sTemp & "              Total Bytes:  " & Format$(lTotalBytes, "###,###,###,###")
            sTemp = sTemp & " (" & Format$(lTotalBytes / (1024& * 1024&), "###,###.##") & " MB)" & vbCrLf
            
            sTemp = sTemp & "              Free Bytes:  " & Format$(lTotalFreeBytes, "###,###,###,##0")
            sTemp = sTemp & " (" & Format$(lTotalFreeBytes / (1024& * 1024&), "###,##0.##") & " MB)" & vbCrLf
            
            If cBytesFreeToCaller <> 0 Then
                sTemp = sTemp & "              Free Bytes Available to User:  " & Format$(lBytesFreeToCaller, "###,###,###,##0")
                sTemp = sTemp & " (" & Format$(lBytesFreeToCaller / (1024& * 1024&), "###,##0.##") & " MB)" & vbCrLf
            End If
            
            'Get the name of the file system (FAT, FAT32, NTFS)
            sBuffer = Space$(255)
            nBuffer = Len(sBuffer)
            lResult = GetVolumeInformation(sRootDir, vbNullString, 0, _
            lSerialNumber, lMaxCompLen, lFileSysFlags, sBuffer, nBuffer)
            sTemp = sTemp & "              File System: " & RemoveNulls(sBuffer) & vbCrLf
            
        Case DRIVE_REMOTE
            'get its UNC name
            sBuffer = String$(255, 0)
            'don't forget to drop the "\" from the root for this call
            lResult = WNetGetConnection(Left$(sRootDir, 2), sBuffer, Len(sBuffer))
            If lResult = 0 Then
                sTemp = sTemp & "     " & sRootDir & "     " & sBuffer & vbCrLf
           End If
        Case DRIVE_CDROM
            sTemp = sTemp & "     " & sRootDir & "     [CD-ROM]" & vbCrLf
        Case DRIVE_RAMDISK
            sTemp = sTemp & "     " & sRootDir & "     [ramdisk]" & vbCrLf
    End Select
Loop

Text1 = sTemp

End Sub

Private Sub Command1_Click()

Dim WinVerInfo As WINVERSIONINFO
Dim bSuccess As Boolean

'Get information about the Window platform and version
bSuccess = GetWinVerInfo(WinVerInfo)
If bSuccess Then
    Call GetDriveInfo(WinVerInfo.Build)
End If


End Sub


Private Sub Form_Load()

Text1 = ""

End Sub


