Attribute VB_Name = "SuperFastSearch"
Option Explicit

Public Declare Function FindFirstFile& Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA)
Public Declare Function FindNextFile& Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA)
Public Declare Function FindClose& Lib "kernel32" (ByVal hFindFile As Long)


Public Const MAX_PATH& = 260
Public Const FILE_ATTRIBUTE_DIRECTORY& = &H10

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type
Public Sub SearchFile(Path As String, ExtToFind As String, LstBox As ListBox)
Dim mywin As WIN32_FIND_DATA
Dim searchhandle As Long
Dim testfilestring As String
Dim morefiles As Boolean
   
   morefiles = True

If Right(Path, 1) <> "\" Then Path = Path & "\"

searchhandle = FindFirstFile(Path & "*.*", mywin)

If mywin.dwFileAttributes <> FILE_ATTRIBUTE_DIRECTORY Then
     testfilestring = mywin.cFileName
     testfilestring = StripNull(testfilestring)
     If UCase(Right(testfilestring, 3)) = UCase(ExtToFind) Then LstBox.AddItem Path & testfilestring
Else
     testfilestring = StripNull(mywin.cFileName)
     If testfilestring <> "." And testfilestring <> ".." Then
     Call SearchFile(Path & testfilestring, ExtToFind, LstBox)
     End If
End If

Do While morefiles = True
     morefiles = FindNextFile(searchhandle, mywin)
       If morefiles = True Then
          If mywin.dwFileAttributes <> FILE_ATTRIBUTE_DIRECTORY Then
            testfilestring = mywin.cFileName
            testfilestring = StripNull(testfilestring)
            If UCase(Right(testfilestring, 3)) = UCase(ExtToFind) Then LstBox.AddItem Path & testfilestring
          Else
            testfilestring = mywin.cFileName
            testfilestring = StripNull(testfilestring)
            If testfilestring <> "." And testfilestring <> ".." Then Call SearchFile(Path & testfilestring, ExtToFind, LstBox)
          End If
       Else
          Call FindClose(searchhandle)
          Exit Sub
       End If
Loop

End Sub




Public Function StripNull(Usestr As String) As String
Dim position As Integer
    position = InStr(Usestr, Chr$(0))
    If position <= 1 Then
        StripNull = ""
        Exit Function
    End If
    StripNull = Left$(Usestr, position - 1)
End Function












Public Sub SearchExactFile(Path As String, FileToFind As String, LstBox As ListBox)

Dim mywin As WIN32_FIND_DATA
Dim searchhandle As Long
Dim testfilestring As String
Dim morefiles As Boolean
  
   morefiles = True

If Right(Path, 1) <> "\" Then Path = Path & "\"

searchhandle = FindFirstFile(Path & "*.*", mywin)

If mywin.dwFileAttributes <> FILE_ATTRIBUTE_DIRECTORY Then
     testfilestring = mywin.cFileName
     testfilestring = StripNull(testfilestring)
     If UCase(testfilestring) = UCase(FileToFind) Then LstBox.AddItem Path & testfilestring
Else
     testfilestring = StripNull(mywin.cFileName)
     If testfilestring <> "." And testfilestring <> ".." Then
     Call SearchExactFile(Path & testfilestring, FileToFind, LstBox)
     End If
End If

Do While morefiles = True
     morefiles = FindNextFile(searchhandle, mywin)
       If morefiles = True Then
          If mywin.dwFileAttributes <> FILE_ATTRIBUTE_DIRECTORY Then
            testfilestring = mywin.cFileName
            testfilestring = StripNull(testfilestring)
            If UCase(testfilestring) = UCase(FileToFind) Then LstBox.AddItem Path & testfilestring
          Else
            testfilestring = mywin.cFileName
            testfilestring = StripNull(testfilestring)
            If testfilestring <> "." And testfilestring <> ".." Then Call SearchExactFile(Path & testfilestring, FileToFind, LstBox)
          End If
       Else
          Call FindClose(searchhandle)
          Exit Sub
       End If
Loop

End Sub






